unit Unit1;

(*
 Kyttliittym on samantyyppinen kuin Tappio.exe -kirjanpito-ohjelmassa.
 Siihen verrattuna on listty mm:
 - tilikartan, pivkirjan, pkirjan, tuloslaskelman ja taseen tallennus
 - tilikartan, pivkirjan, pkirjan, tuloslaskelman ja taseen kopiointi leikepydlle
 - alv-tilej ja laskelmaa parannettu alv:n kausi-ilmoitusta varten
 - pkirja voidaan avata mys halutulta kuukaudelta

 Kirjanpidon avaus ja tallennus voi tapahtua joko S-tyypin tai csv-formaatissa.
 S-tyyppi on *.tlk eli sama kuin Tappio.exe -ohjelmassa.
 Csv-tyyppi on suoraan Delphin rutiini.

 Tallennettu S-tyypin tiedosto ei vlttmtt en toimi Tappio.exe:ss,
 ainakaan jos on tehty sellaisia muutoksia, joita se ei tue.

 HUOM! About-teksti proceduurissa TForm1.Ohjelma1Click();

 Muutoksia:
 7.12.2012 DrawRow4-proceduurissa muutettu TextOut -> TextRect, jossa Rect.Left
           asetetaan niin, ett se puhdistaa edellisen, ylipitkn tekstin.

           Vlisaldot-valinta pkirjaan
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, StdCtrls, ExtCtrls, Buttons, Grids;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Save1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Muokkaa1: TMenuItem;
    Add2: TMenuItem;
    ClearAll2: TMenuItem;
    ExpandAll1: TMenuItem;
    CollapseAll1: TMenuItem;
    N1: TMenuItem;
    Close1: TMenuItem;
    SaveAs1: TMenuItem;
    Muokkaa2: TMenuItem;
    N2: TMenuItem;
    Marginaalit1: TMenuItem;
    Font1: TMenuItem;
    N3: TMenuItem;
    RowCap1: TMenuItem;
    N4: TMenuItem;
    Bottom1: TMenuItem;
    Right1: TMenuItem;
    Top1: TMenuItem;
    Left1: TMenuItem;
    N5: TMenuItem;
    Save2: TMenuItem;
    Copy1: TMenuItem;
    N6: TMenuItem;
    Otsikkorivit1: TMenuItem;
    PrintDialog1: TPrintDialog;
    FontDialog1: TFontDialog;
    PopupMenu1: TPopupMenu;
    CopyAll1: TMenuItem;
    Uusi1: TMenuItem;
    PaivakirjaMenu1: TPopupMenu;
    MuokTosite1: TMenuItem;
    UusiTosite1: TMenuItem;
    PoistaViimeinen1: TMenuItem;
    TilikarttaMenu1: TPopupMenu;
    MenuItem1: TMenuItem;
    UusiAlatili2: TMenuItem;
    MenuItem3: TMenuItem;
    N7: TMenuItem;
    Muutaperustietoja1: TMenuItem;
    Update1: TMenuItem;
    Update2: TMenuItem;
    LastFile1: TMenuItem;
    Yllpitosivu1: TMenuItem;
    TabPaikat1: TMenuItem;
    TabEditor1: TStringGrid;
    Perustiedot1: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    YritNimi1: TEdit;
    UusiPvm1: TEdit;
    UusiPvm2: TEdit;
    Button1: TButton;
    Button2: TButton;
    KkBox1: TGroupBox;
    KkNro1: TComboBox;
    Ok3: TButton;
    Cancel3: TButton;
    TreeMenu2: TPopupMenu;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    Laajenna1: TMenuItem;
    SupistaTree1: TMenuItem;
    Poista1: TMenuItem;
    UusiKausi1: TMenuItem;
    Alvtekstit1: TMenuItem;
    N8: TMenuItem;
    Print1: TMenuItem;
    Print2: TMenuItem;
    Tulosta1: TMenuItem;
    Tiliote1: TMenuItem;
    Print3: TMenuItem;
    Ohje2: TMenuItem;
    Ohjelma1: TMenuItem;
    N9: TMenuItem;
    PaivNrot1: TMenuItem;
    Valisaldot1: TMenuItem;
    TilikarttaPrint1: TGroupBox;
    OK4: TButton;
    Cancel4: TButton;
    Luettelo1: TRadioButton;
    Kartta1: TRadioButton;
    Print4: TMenuItem;
    Alvmuut1: TButton;
    AlvMuutPanel: TGroupBox;
    AlvMuutGrid1: TStringGrid;
    Ok5: TButton;
    Cancel5: TButton;
    Label1: TLabel;
    Label2: TLabel;
    VvNro1: TComboBox;
    KopioiTosite1: TMenuItem;
    N10: TMenuItem;
    PageControl1: TPageControl;
    TiliSheet1: TTabSheet;
    Tilikartta: TTreeView;
    PaivaSheet2: TTabSheet;
    Paivakirja: TTreeView;
    PaaSheet3: TTabSheet;
    Paakirja1: TListBox;
    TulosSheet4: TTabSheet;
    TulosLaskelma1: TListBox;
    TaseSheet5: TTabSheet;
    Tase1: TListBox;
    AlvLaskelma1: TTabSheet;
    AlvSivu1: TListBox;
    TreeSheet1: TTabSheet;
    TreeView1: TTreeView;
    Vertailukausi1: TMenuItem;
    TreeSheet2: TTabSheet;
    TreeView2: TTreeView;
    Suodatin1: TGroupBox;
    Suod1: TEdit;
    SuodOK: TButton;
    SuodatinOn: TCheckBox;
    Label3: TLabel;
    Label7: TLabel;
    Suodatin2: TMenuItem;
    Label8: TLabel;
    SuodOtsikko: TEdit;
    N12: TMenuItem;
    Etsi2: TMenuItem;
    Etsiseuraava2: TMenuItem;
    procedure Open1Click(Sender: TObject);
    procedure Add1Click(Sender: TObject);
    procedure Remove1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure ClearAll1Click(Sender: TObject);
    procedure ExpandAll1Click(Sender: TObject);
    procedure CollapseAll1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure TreeView1DblClick(Sender: TObject);
    procedure SaveTlkClick(Sender: TObject);
    procedure TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure Cancel3Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure Save2Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure Marginaalit1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Left1Click(Sender: TObject);
    procedure RowCap1Click(Sender: TObject);
    procedure Otsikkorivit1Click(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure PageControl1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TulosLaskelma1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure Paakirja1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure PaivakirjaDblClick(Sender: TObject);
    procedure Uusi1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Pvm1Click(Sender: TObject);
    procedure Pvm1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PaivakirjaMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure UusiTosite1Click(Sender: TObject);
    procedure TilikarttaDblClick(Sender: TObject);
    procedure TilikarttaMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure UusiAlatili2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure Print2Click(Sender: TObject);
    procedure Ok3Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Update1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure File1Click(Sender: TObject);
    procedure AdminPage1Click(Sender: TObject);
    procedure PageControl1Changing(Sender: TObject;
      var AllowChange: Boolean);
    procedure TabPaikat1Click(Sender: TObject);
    procedure TabEditor1DrawCell(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure TabEditor1DblClick(Sender: TObject);
    procedure TabEditor1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TabEditor1SelectCell(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure TreeView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PoistaViimeinen1Click(Sender: TObject);
    procedure Ohje1Click(Sender: TObject);
    procedure TilikarttaMenu1Popup(Sender: TObject);
    procedure TilikarttaDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure TilikarttaDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure UusiPvm1KeyPress(Sender: TObject; var Key: Char);
    procedure Alvtekstit1Click(Sender: TObject);
    procedure Ohjelma1Click(Sender: TObject);
    procedure UusiPvm1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PaivakirjaDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure PaivNrot1Click(Sender: TObject);
    procedure Muokkaa2Click(Sender: TObject);
    procedure Valisaldot1Click(Sender: TObject);
    procedure Print4Click(Sender: TObject);
    procedure Cancel4Click(Sender: TObject);
    procedure OK4Click(Sender: TObject);
    procedure Alvmuut1Click(Sender: TObject);
    procedure Cancel5Click(Sender: TObject);
    procedure AlvMuutGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure AlvMuutGrid1SelectCell(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure Ok5Click(Sender: TObject);
    procedure KkNro1Change(Sender: TObject);
    procedure VvNro1Change(Sender: TObject);
    procedure Vertailukausi1Click(Sender: TObject);
    procedure SuodOKClick(Sender: TObject);
    procedure Suodatin2Click(Sender: TObject);
    procedure Etsi1Click(Sender: TObject);
    procedure Etsiseuraava1Click(Sender: TObject);
    procedure KeyDown1(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Tase1DblClick(Sender: TObject);
  private
    { Private declarations }
    BaseLevel, Voitto2, AlvEditRow, HakuIx: Integer;
    Miinus, ValiSaldot, KkVvChange, VertailuOn, HakuOn: Boolean;
    ListItems: TStrings;
    HakuTreeView: TTreeView;
    HakuListBox: TListBox;
    SuodatinText, HakuStr: String;
    procedure LoadTreeNode(TreeNodes2: TTreeNodes ;TreeNode2: TTreeNode; Jono: PChar; var Ix: Integer; MaxIx: Integer);
    procedure SaveTreeNode(TreeNode2: TTreeNode; var Jono: String);
    procedure FindNodeTxts(TreeNode: TTreeNode; NodeList: TList; const KeyStr: String);
    function FindTreeKey(const KeyStr: String; TreeNode: TTreeNode):TTreeNode;
    function GetTreeDate(TreeNode: TTreeNode; var Ix: Integer): String;
    function TositeSumma(SL: Pointer): Integer;
    function AddTulosAccount(TreeNode1, TreeNode2: TTreeNode; StringList: TStrings; var ApuR: Integer): Integer;
    function SummaStr(Sum: Integer): String;
    procedure TeePaivakirja(SourNode, DestNode: TTreeNode);
    procedure TeeTilikartta(SourNode, DestNode: TTreeNode);
    procedure Otsikko(const Txt: String; SList: TStrings);
    procedure OpenTlk(TreeView: TTreeView; FileName: String);
    procedure OpenTilikartta;
    procedure OpenPaivakirja;
    procedure OpenPaakirja;
    procedure DrawRow(Canvas: TCanvas; ApuS: String; Rect: TRect);
    procedure DrawRow4(Canvas: TCanvas; ApuS: String; Rect: TRect);
    function VatFromStr(const S: String; Ts: TStrings): Integer;
    procedure TeeTiliLista(Node: TTreeNode; Accounts: TStringList);
    procedure OpenAlvLaskelma;
    procedure TeeAlvLaskelma;
    procedure ListPvKirja;
    procedure PrintPvKirja;
    procedure TeePaakirja;
    function YritysNimi: String;
    function KausiPvm(Ix: Integer; OtsNode: TTreeNode): String;
    procedure TabEditWidths(It: Integer);
    procedure TilikaudenVaihto;
    function TeeAvausNode: TTreeNode;
    function Talteenko: Word;
    procedure SetCaption;
    procedure CopyPvList;
    procedure CopyList;
    procedure AlvMuutCellFix;
    function TiliVuodet(const PvmStr1, PvmStr2: String): Boolean;
    function VertPvm(const Pvm: String): Integer;
    procedure KkBox1Start;
    function ClearVertailu: Boolean;
    procedure AddNodes(TreeNode1, TreeNode2: TTreeNode);
    procedure AddAccounts;
    procedure HaeString;
    function HaeNodeStr(ANode: TTreeNode): Boolean;
    procedure HaeListString;
  public
    { Public declarations }
    procedure ShowPopup(Cntrl: TControl; PopupA: TPopupMenu; ApuP: TPoint);
    function GetAccountName(Txt: String): String;
    procedure TeeAccountList1;
    procedure TeeAccountList2;
    procedure OpenTulosTase(AbsSum: Boolean);
    procedure GetTosite;
    procedure TeeTili(SourNode, DestNode: TTreeNode);
    procedure ReadIni;
    procedure WriteIni;
  end;

var
  Form1: TForm1;
  Accounts1, Accounts2, AccountNames, VatDropTxts, VatListTxts: TStringList;
  OtsikkoNode, AccountNode, EventNode, OtsikkoNode2, AccountNode2, EventNode2, TiliNode, EditNode: TTreeNode;
  DirtyFlag, Voitto: Integer;
  UusiAlaTili, Muuttunut: Boolean;
  IniFileName, VahVeroTxt, MaksVeroTxt: String;

const
  Tab = #9;
  Bold = #2;       { ^B }
  Under = #$1F;    { ^U }
  AccountTxt: String = 'account';
  MoneyTxt: String = 'money';
  FiscalYearTxt: String = 'fiscal-year';
  DateTxt: String = 'date';
  VatmTxt: String = 'vat-m';
  AccountMapTxt: String = 'account-map';
  VastaavaaTxt: String = 'Vastaavaa';
  VastattavaaTxt: String = 'Vastattavaa';
  TulosTxt: String = 'Tulos';
  EventTxt: String = 'event';
  VahVeroTxt1 = 'Vhennettv vero';
  MaksVeroTxt1 = 'Maksettava vero';

  // alv-koodit
  VatTexts: array[0..13] of String = (
            '-',    // ei alv-tili
            'sales',        // Myynti, vaatii alv-%:n
            'credit',       // Myynnin alv-velkatili, vaatii alv-%:n
            'purchase',     // Osto, alv-% vapaaehtoinen
            'debit',        // Ostojen alv, ei alv-%
            'eugsales',     // EU-myynti tavara, ei alv-%
            'eussales',     // EU-myynti palvelu, ei alv-%
            'eugpurchase',  // EU-osto tavara, ei alv-%
            'euspurchase',  // EU-osto palvelu, ei alv-%
            'eugdebit',     // EU-oston alv tavara, ei alv-%
            'eusdebit',     // EU-oston alv palvelu, ei alv-%
            'bsales',       // Myynti rakent.palvelu, ei alv-%
            'bpurchase',    // Osto rakent.palvelu, ei alv-%
            'bdebit');       // Ostojen alv rak.palvelu, ei alv-%

implementation

uses clipbrd, printers, inifiles, SubRut, Unit2, HHelp;

{$R *.DFM}

const
  // Vastaavat droplist-tekstit. Nit voi kustomoida.
  VatDrops: array[0..13] of String = (
            '-',
            'Myynti',
            'Myynnin alv',
            'Osto',
            'Ostojen alv',
            'EU-myynti tavara',
            'EU-myynti palvelu',
            'EU-osto tavara',
            'EU-osto palvelu',
            'EU-oston alv tavara',
            'EU-oston alv palvelu',
            'Myynti rakent.palvelu',
            'Osto rakent.palvelu',
            'Ostojen alv rak.palvelu');

  MargTxt: array[0..3] of String = ('Left', 'Top', 'Right', 'Bottom');

var
  Marg: array[0..5] of array[0..3] of Integer;
  RowCap: array[0..5] of Integer;
  PrintFont: array[0..5] of String;
  PrintSize: array[0..5] of Integer;
  OtsRivit: array[0..5] of Integer;
  TabId: Integer;
  LastKk, MaxKk: Longint;  //hi=vv, lo=kk
  ValKkS, ValKkS2: String;
  OkFlag, UusiKausi, KaudenVaihto: Boolean;
  PrintKesken, TaseSum: Integer;

procedure TForm1.Ohjelma1Click(Sender: TObject);
begin
  ShowMessage('Kirjanpito-ohjelma'#13#10'Holli.exe ver. 2.03'#13#10'Ilmaisohjelma (Freeware)'#13#10' Elektro-Palomki ky');
end;

{ hiritsev Hint (tooltip) poistetaan TreeView'st }
procedure HideTreeHint(TreeView: TTreeView);
var
  IStyle: Integer;
begin
  { ShowHint := False ei toimi, kytetn Windows-kutsua }
  IStyle := GetWindowLong(TreeView.Handle, GWL_STYLE);  { GWL_STYLE = -16 }
  IStyle := IStyle or $0080;                            { TVS_NOTOOLTIPS = $0080; }
  SetWindowLong(TreeView.Handle, GWL_STYLE, IStyle);
end;

{ ohjelman alkurutiinit }
procedure TForm1.FormCreate(Sender: TObject);
begin
  ForceCurrentDirectory := True;
  KkVvChange := False;
  DecimalSeparator := DesP;    // kytetn desimaalipilkkua
  Left := 0;
  Top := 0;
  if Height > (Screen.Height - 40) then Height := Screen.Height - 40;
  if Width > Screen.Width then Width := Screen.Width;
  HideTreeHint(TreeView1);
  HideTreeHint(TreeView2);
  HideTreeHint(Tilikartta);
  HideTreeHint(Paivakirja);
  Accounts1 := TStringList.Create;
  Accounts2 := TStringList.Create;
  Accounts1.Sorted := True;
  Accounts2.Sorted := True;
  AccountNames := TStringList.Create;
  AccountNames.Sorted := True;
  VatDropTxts := TStringList.Create;
  VatListTxts := TStringList.Create;
  if ParamCount > 0
  then IniFileName := ExtractFileDir(ParamStr(0)) + '\' + ParamStr(1) + '.ini'
  else IniFileName := ChangeFileExt(ParamStr(0), '.ini');
  ReadIni;
  ChmFile := ChangeFileExt(ParamStr(0), '.chm');
  TabId := 1;
  ListItems := Paakirja1.Items;
  HakuTreeView := nil;
  HakuListBox := nil;
  TreeSheet1.TabVisible := False;
  TreeSheet2.TabVisible := False;
  PageControl1.ActivePage := PaivaSheet2;
  DirtyFlag := $FFFF;
  PageControl1.Align := alClient;
  Muuttunut := False;
  PrintKesken := 0;
end;

{ ohjelman loppurutiinit }
function TForm1.YritysNimi: String;
var
  Ix: Integer;
begin
  Ix := Length(FiscalYearTxt);
  if OtsikkoNode <> nil
  then Result := StrFromStr(OtsikkoNode.Text, '"', '"', Ix)
  else Result := '';
end;

function TForm1.KausiPvm(Ix: Integer; OtsNode: TTreeNode): String;
var
  Iy: Integer;
begin
  if OtsNode <> nil then
  begin
    Iy := 0;
    repeat
      Result := GetTreeDate(OtsNode, Iy);
      Dec(Ix);
    until Ix <= 0;
  end
  else Result := '00.00.0000';
end;

procedure TForm1.SetCaption;
begin
  Caption := 'Kirjanpito ' + YritysNimi + ' ' + KausiPvm(1, OtsikkoNode) + ' - ' + KausiPvm(2, OtsikkoNode);
end;

{ .tlk- tai .csv-tyyppisen treeview-tiedoston avaus }
procedure TForm1.Open1Click(Sender: TObject);
begin
  if Talteenko <> mrCancel then
  with OpenDialog1 do
  begin
    FilterIndex := 2;
    if ((TMenuItem(Sender).Tag = 1) and FileExists(FileName))
    or Execute then
    begin
      ClearVertailu;
      if UpperCase(ExtractFileExt(FileName)) = '.TLK'
      then OpenTlk(TreeView1, FileName)
      else TreeView1.LoadFromFile(FileName);
      SaveDialog1.FileName := FileName;
      PageControl1.Show;
      DirtyFlag := $FFFF;
      Muuttunut := False;
      EventNode := nil;
      TeeAccountList1;
      if not TiliVuodet(KausiPvm(1, OtsikkoNode), KausiPvm(2, OtsikkoNode))
      then ShowMessage('Virheellinen tilikausi');
      PageControl1.ActivePage := PaivaSheet2;
      PageControl1Change(Sender);
      SetCaption;
    end;
  end;
end;

// suljetaan vertailukausi
function TForm1.ClearVertailu: Boolean;
begin
  Result := TreeView2.Items.Count > 0;
  if Result then
  begin
    TreeView2.Items.Clear;
    VertailuOn := False;
    DirtyFlag := $FFFF;
    Vertailukausi1.Caption := 'Avaa vertailukausi';
    AccountNode2 := nil;
  end;
end;

// avataan vertailukausi
procedure TForm1.Vertailukausi1Click(Sender: TObject);
var
  FileN: String;
begin
  if ClearVertailu
  then PageControl1.ActivePage := PaivaSheet2
  else with OpenDialog1 do
  begin
    FileN := FileName;
    FilterIndex := 2;
    if Execute then
    begin
      if UpperCase(ExtractFileExt(FileName)) = '.TLK'
      then OpenTlk(TreeView2, FileName)
      else TreeView2.LoadFromFile(FileName);
      if TreeView2.Items.Count > 0 then
      begin
        VertailuOn := True;
        TeeAccountList2;
        DirtyFlag := DirtyFlag or 8;
        Vertailukausi1.Caption := 'Sulje vertailukausi';
        PageControl1.ActivePage := PaivaSheet2;
      end;
    end;
    FileName := FileN;
  end;
end;

{ treeview, noden lisys }
procedure TForm1.Add1Click(Sender: TObject);
var
  sText: String;
begin
   DirtyFlag := $FFFF;
   Muuttunut := True;
      {If nothing is selected}
   if(TreeView1.Selected = nil) then
   begin
         {If there is no root node}
      if(TreeView1.Items.Count = 0) then
      begin
            {Add the root node}
         with TreeView1.Items.AddFirst(nil, 'Root') do
		 begin
               {Select the root node}
            Selected := true;
         end;
      end
      else begin
            {There is a root, so user must first select
            a node before adding a new node}
         MessageBeep($FFFFFFFF);
         ShowMessage('Select a parent node');
         Exit;
      end;
   end
   else begin
         {Get a name for the new node}
      InputQuery('New Node', 'Caption ?', sText);

         {Add the node as a child of the selected node}
      with TreeView1.Items.AddChildFirst(TreeView1.Selected, sText) do
      begin
         MakeVisible;
      end;
   end;
end;

{ treeview, noden poisto }
procedure TForm1.Remove1Click(Sender: TObject);
begin
   DirtyFlag := $FFFF;
   Muuttunut := True;
      {Make sure somthing is selected, before trying to
        delete it}
   if(TreeView1.Selected = nil) then
   begin
      MessageBeep($FFFFFFFF);
      ShowMessage('Nothing selected');
      Exit;
   end;

      {Dont allow user to delete the root node}
   if(TreeView1.Selected.Level = 0) then
   begin
      MessageBeep($FFFFFFFF);
      ShowMessage('Cant delete the root node');
      Exit;
   end;


      {Delete the node}
   TreeView1.Selected.Delete;

end;

{ treeview'in tallennus .csv-tyyppisen }
procedure TForm1.Save1Click(Sender: TObject);
begin
  if TreeView1.Items.Count > 0 then
  with SaveDialog1 do
  begin
    FilterIndex := 2;
    DefaultExt := 'csv';
    if ((TMenuItem(Sender).Tag = 1) or not FileExists(FileName))
    and not Execute then Exit;
    if UpperCase(ExtractFileExt(FileName)) = '.TLK'
    then SaveTlkClick(Sender)
    else TreeView1.SaveToFile(FileName);
    OpenDialog1.FileName := FileName;
    Muuttunut := False;
  end;
end;

{ muokkaa S-tyypin tiedostosta treeview'in }
procedure TForm1.LoadTreeNode(TreeNodes2: TTreeNodes ;TreeNode2: TTreeNode; Jono: PChar; var Ix: Integer; MaxIx: Integer);
var
  ApuS: String;
  Mjono: Boolean;
  UusNode: TTreeNode;
begin
  repeat
    Mjono := False;
    if Jono[Ix] <> '"' then Inc(Ix);
    ApuS := '';
    while (Ix < MaxIx) and (Mjono or not (Jono[Ix] in ['(', ')'])) do
    begin
      if Jono[Ix] = '"' then Mjono := not Mjono;
      if Mjono and (Jono[Ix] = '\') then Inc(Ix);
      ApuS := ApuS + Jono[Ix];
      Inc(Ix);
    end;
    ApuS := Trim(ApuS);
    if (Length(ApuS) > 0) and (ApuS[1] = '"') and (ApuS[Length(ApuS)] = '"') then Dec(Ix);  // merkkijono
    UusNode := TreeNodes2.AddChild(TreeNode2, ApuS);
    if Jono[Ix] = '(' then
      LoadTreeNode(TreeNodes2, UusNode, Jono, Ix, MaxIx)
    else Inc(Ix);
    while (Ix < MaxIx) and (Jono[Ix] in [#9, #10, #13, ' ']) do Inc(Ix);
  until (Ix >= MaxIx) or (Jono[Ix] = ')');
  Inc(Ix);
  while (Ix < MaxIx) and (Jono[Ix] in [#9, #10, #13, ' ']) do Inc(Ix);
end;

{ avataan S-tyyppinen tiedosto }
procedure TForm1.OpenTlk(TreeView: TTreeView; FileName: String);
var
  Ms: TMemoryStream;
  Ix, Imax: Integer;
begin
  TreeView.Items.Clear;
  Ms := TMemoryStream.Create;
  Ms.LoadFromFile(FileName);
  Imax := Ms.Size;
  Ix := 0;
  if Imax > 2
  then LoadTreeNode(TreeView.Items, nil, PChar(Ms.Memory), Ix, Imax);
  Ms.Free;
end;

 //onko merkkijono lista
function OnList(const Sx: String): Boolean;
begin
  Result :=
  (Length(Sx) > 0) and
  ((Length(Sx) < 2) or (Sx[1] <> '"') or (Sx[Length(Sx)] <> '"')) and
  (Pos(' ', Sx) > 0);
end;

{ Muunnetaan Tree S-tyypin merkkijonoon }
procedure TForm1.SaveTreeNode(TreeNode2: TTreeNode; var Jono: String);
var
  Ix: Integer;
begin
  if ((TreeNode2.Count = 0) and (Length(TreeNode2.Text) = 0))
  or (TreeNode2.Count > 0) or OnList(TreeNode2.Text) then
  begin
    if (Length(Jono) > 0) and not (Jono[Length(Jono)] in [' ', '('])
    then Jono := Jono + ' ';
    Jono := Jono + '(' + TreeNode2.Text;
    if TreeNode2.Count > 0 then
    for Ix := 0 to TreeNode2.Count - 1 do
    begin
      if Ix > 0 then Jono := Jono + ' ';
      SaveTreeNode(TreeNode2.Item[Ix], Jono);
    end;
    Jono := Jono + ')';
  end
  else Jono := Jono + TreeNode2.Text;
end;

{ tallennetaan S-tyypin (*.tlk) tiedosto }
procedure TForm1.SaveTlkClick(Sender: TObject);
var
  Ms: TMemoryStream;
  Jono: String;
begin
  Jono := '';
  SaveTreeNode(TreeView1.Items[0], Jono);
  Ms := TMemoryStream.Create;
  Ms.WriteBuffer(Jono[1], Length(Jono));
  Ms.SaveToFile(SaveDialog1.FileName);
  Ms.Free;
end;


procedure TForm1.ClearAll1Click(Sender: TObject);
begin
  TreeView1.Items.Clear;
  ClearVertailu;
  Accounts1.Clear;
  Accounts2.Clear;
  AccountNames.Clear;
end;

procedure TForm1.ExpandAll1Click(Sender: TObject);
begin
  TreeView1.FullExpand;
  TreeView2.FullExpand;
end;

procedure TForm1.CollapseAll1Click(Sender: TObject);
begin
  TreeView1.FullCollapse;
  TreeView2.FullCollapse;
end;

{ Kertn kaikki KeyStr:ll alkavat nodet listaan }
procedure TForm1.FindNodeTxts(TreeNode: TTreeNode; NodeList: TList; const KeyStr: String);
var
  Ix: Integer;
begin
  if StrLComp(PChar(KeyStr), PChar(TreeNode.Text), Length(KeyStr)) = 0
  then NodeList.Add(TreeNode);
  if TreeNode.Count > 0 then
  for Ix := 0 to TreeNode.Count - 1 do FindNodeTxts(TreeNode.Item[Ix], NodeList, KeyStr);
end;

{ haetaan, jos lytyy avaimen mukainen teksti TreeNoden alinodeista }
function TForm1.FindTreeKey(const KeyStr: String; TreeNode: TTreeNode): TTreeNode;
var
  Ix: Integer;
begin
  Result := Nil;
  Ix := 0;
  while (Ix < TreeNode.Count) and (Result = Nil) do
  begin
    if StrLComp(PChar(KeyStr), PChar(TreeNode.Item[Ix].Text), Length(KeyStr)) = 0
    then Result := TreeNode.Item[Ix];
    Inc(Ix);
  end;
end;

{ haetaan, jos lytyy pivys TreeNoden alinodeista }
function TForm1.GetTreeDate(TreeNode: TTreeNode; var Ix: Integer): String;
var
  ApuS1, ApuS2, ApuS3: String;
  Ia: Longint;
begin
  Result := '??.??.????';
  while Ix < TreeNode.Count do
  begin
    if Pos(DateTxt, TreeNode.Item[Ix].Text) = 1 then
    begin
      Ia := Length(DateTxt);
      ApuS1 := StrFromStr(PChar(TreeNode.Item[Ix].Text), ' ', ' ', Ia);     // vuosi
      while Length(ApuS1) < 4 do Insert('0', ApuS1, 1);
      ApuS2 := StrFromStr(PChar(TreeNode.Item[Ix].Text), ' ', ' ', Ia);     // kk
      while Length(ApuS2) < 2 do Insert('0', ApuS2, 1);
      ApuS3 := StrFromStr(PChar(TreeNode.Item[Ix].Text), ' ', ' ', Ia);     // pv
      while Length(ApuS3) < 2 do Insert('0', ApuS3, 1);
      Result := ApuS3 + '.' + ApuS2 + '.' + ApuS1;
      if (EventNode <> nil) and (TreeNode.Level > EventNode.Level) then
      begin
        LongRec(Ia).Lo := StrToIntDef(ApuS2, 0);
        LongRec(Ia).Hi := StrToIntDef(ApuS1, 0);
        if (LongRec(Ia).Lo in [1..12]) and (Ia > MaxKk) then MaxKk := Ia;
      end;
      Inc(Ix);
      Break;
    end;
    Inc(Ix);
  end;
end;

{ muuntaa integerin valuuttamerkkijonoksi; negatoi, jos Miinus}
function TForm1.SummaStr(Sum: Integer): String;
begin
  if Miinus then Sum := -Sum;
  Result := Format('%.2f', [Sum/100]);
end;

// Listn TreeNode2:een TreeNode1:ss olevat nodet, jos niit ei ole
procedure TForm1.AddNodes(TreeNode1, TreeNode2: TTreeNode);
var
  I1, I2, Iy: Integer;
  Sx, Sy: String;
  ApuNode: TTreeNode;
begin
  I1 := 0;
  I2 := -1;
  while (I1 < TreeNode1.Count) do
  begin
    Sx := TreeNode1.Item[I1].Text;
    ApuNode := FindTreeKey(Sx, TreeNode2);     // onko sama teksti
    if ApuNode = nil then
    begin
      Iy := Length(AccountTxt);                      // account -tekstin pern
      Sy := StrFromStr(Sx, ' ', ' ', Iy);     // tilinumero-osuus
      if StrToIntDef(Sy, -1) > 0 then
      ApuNode := FindTreeKey(Copy(Sx, 1, Iy-1), TreeNode2);     // haetaan tilinumerolla
      if ApuNode <> nil then
      begin                       // lytyi samalla tilinumerolla
        ApuNode.Text := Sx;       // muutetaan teksti tmn kauden mukaiseksi
        I2 := TreeNode2.IndexOf(ApuNode);
      end
      else
      begin
        if (I2+1) < TreeNode2.Count
        then I2 := TreeNode2.IndexOf(TreeView2.Items.Insert(TreeNode2.Item[I2+1], Sx))
        else I2 := TreeNode2.IndexOf(TreeView2.Items.AddChild(TreeNode2, Sx));
      end;
    end
    else I2 := TreeNode2.IndexOf(ApuNode);
    if I2 >= 0 then
    AddNodes(TreeNode1.Item[I1], TreeNode2.Item[I2]);
    Inc(I1);
  end;
end;

procedure TForm1.AddAccounts;
begin
  if VertailuOn and (AccountNode <> nil) and (AccountNode2 <> nil)
  then AddNodes(AccountNode, AccountNode2);
end;

{ lasketaan StringListan objektien summa, SL = TStringList}
function TForm1.TositeSumma(SL: Pointer): Integer;
var
  Ix: Integer;
begin
  Result := 0;
  if (SL <> nil) and (TStringList(SL).Count > 0) then
  for Ix := 0 to TStringList(SL).Count - 1 do
  Result := Result + Integer(TStringList(SL).Objects[Ix]);
end;


{ tuloslaskelman tai taseen kokoamista TreeNodesta ja sen alinodeista
  TreeNode1 on tmn tilikauden Accounts, mutta jos TreeNode2 <> nil, niin
  TreeNode1 on vertailukauden ja TreeNode2 tmn kauden Accounts.
  Vertailukauden Accounts2-listaan on listty mys tmn kauden itemit }
function TForm1.AddTulosAccount(TreeNode1, TreeNode2: TTreeNode; StringList: TStrings; var ApuR: Integer): Integer;
var
  Ix, Iy, Iz, Iq, ApuV: Integer;
  ApuS: String;
  ApuNode: TTreeNode;
begin
  Result := 0;
  ApuR := 0;  // vertailutietojen summaus
  if TreeNode1.Count > 0 then
  begin
    for Ix := 0 to TreeNode1.Count - 1 do
    begin
      if Pos(AccountTxt, TreeNode1.Item[Ix].Text) = 1
      then     // account eli tili tai otsikko, jos tilinro = -1
      begin
        ApuS := SpaceStr(TreeNode1.Item[Ix].Level - BaseLevel, ' ');   //alkuun spaceja riippuen levelist
        Iz := Length(AccountTxt);
        Iy := StrToNextInt(TreeNode1.Item[Ix].Text, Iz);    //tilinumero
        if Iy > 0 then ApuS := ApuS + IntToStr(Iy) + ' ';  //jos on tilinumero
        ApuS := ApuS + StrFromStr(TreeNode1.Item[Ix].Text, '"', '"', Iz);  //tilin tai otsikon nimi
        if Iy > 0 then
        begin
          ApuNode := TreeNode1.Item[Ix];
          if TreeNode2 <> nil then ApuNode := FindTreeKey(ApuNode.Text, TreeNode2);
          if ((ApuNode <> nil) and (ApuNode.Data <> nil)) or ((TreeNode2 <> nil) and (TreeNode1.Item[Ix].Data <> nil)) then
          begin   //pointer tositteiden StringList'aan
            if (ApuNode <> nil) and (ApuNode.Data <> nil)
            then Iq := TositeSumma(ApuNode.Data)    //lasketaan tilin tositesumma
            else Iq := 0;
            ApuS := ApuS + Char(VK_TAB) + SummaStr(Iq);   //tabulaattorimerkill erotettuna summa
            if Pos('@', TreeNode1.Item[Ix].Text) > 0      { @-merkki on tilikauden voittotili, jota ei lasketa tulokseen }
            then Voitto2 := Iq
            else
            begin
              Result := Result + Iq;
              if TreeNode2 <> nil then
              begin // vertailutiedot
                Iq := TositeSumma(TreeNode1.Item[Ix].Data);    //lasketaan tilin tositesumma
                ApuS := ApuS + Char(VK_TAB) + SummaStr(Iq);   //tabulaattorimerkill erotettuna summa
                ApuR := ApuR + Iq;
              end;
              StringList.Add(ApuS);
            end;
          end;
        end
        else
        begin
          Iz := Pos('#', ApuS);
          if Iz > 0 then
          begin
            Delete(ApuS, Iz, 1);
            ApuS := ApuS + Char(VK_TAB) + SummaStr(Result);
          end;
          StringList.Add(ApuS);
        end;
      end;
      ApuNode := nil;
      if (TreeNode2 <> nil) and (TreeNode2.Count > Ix) then ApuNode := TreeNode2.Item[Ix];
      if TreeNode1.Item[Ix].Count > 0 then
      begin
        Result := Result + AddTulosAccount(TreeNode1.Item[Ix], ApuNode, StringList, ApuV);
        ApuR := ApuR + ApuV;
      end;
    end;
    // "account -1" tarkoittaa tilikartan otsikkotileja, joilla ei ole tilinumeroa
    if (Pos(AccountTxt, TreeNode1.Text) = 1) then // and (Pos('-1', TreeNode1.Text) > 0) then
    begin
    if (Pos('#', TreeNode1.Text) = 0) then    // ei vlitulos
      begin
        Iz := Length(AccountTxt);                              // listty 2.9.2011
        if StrToNextInt(TreeNode1.Text, Iz) <= 0 then           // listty 2.9.2011
        begin
          if (TreeNode1.Level = BaseLevel) and (Voitto <> 0) then
          begin
            Result := Result + Voitto;
            StringList.Add(' Tilikauden tulos' + Char(VK_TAB) + SummaStr(Voitto));
            StringList.Add('');
          end;
          ApuS := SpaceStr(TreeNode1.Level - BaseLevel, ' ') +
            'Yht. ' + StrFromStr(TreeNode1.Text, '"', '"', Iz) +
            Char(VK_TAB) + SummaStr(Result);
          if TreeNode2 <> nil then      // vertailutiedot
            ApuS := ApuS + Char(VK_TAB) + SummaStr(ApuR);
          StringList.Add(ApuS);
          StringList.Add('');
        end;
      end
      else StringList.Add('');
    end;
  end;
end;

{ tuloslaskelman tai taseen otsikkotiedot: yritys ja Txt + tilikausi }
procedure TForm1.Otsikko(const Txt: String; SList: TStrings);
var
  Ix: Integer;
  ApuS, ApuT: String;
begin
  if OtsikkoNode = nil then Exit;
  ApuT := KausiPvm(2, OtsikkoNode);
  ApuS := YritysNimi + ' ' + KausiPvm(1, OtsikkoNode) + ' - ' + ApuT;
  if VertailuOn and (TabId in [3..4]) then
  ApuS := ApuS + Char(VK_TAB) + ApuT + Char(VK_TAB) + KausiPvm(2, OtsikkoNode2);
  Ix := 1;
  while (Ix < Length(Txt)) and (Txt[Ix] <= ' ') do Inc(Ix);
  { ApuS:n alkuun samat kontrollimerkit kuin Txt:ss }
  if Ix > 1 then ApuS := Copy(Txt, 1, Ix - 1) + ApuS;
  SList.Add(ApuS);
  SList.Add(Txt);
  SList.Add('');
end;

{ tehdn tulos ja tase }
procedure TForm1.OpenTulosTase(AbsSum: Boolean);
var
  ApuI, ApuV: Integer;
  MaxKkS: String;
  ApuNode1, ApuNode2: TTreeNode;
begin
  DirtyFlag := DirtyFlag and $FFF7;
  AddAccounts;
  Voitto := 0;
  Voitto2 := 0;
  ApuV := 0;
  if TreeView1.Items.Count > 0 then
  begin
    Tuloslaskelma1.Clear;
    Tase1.Clear;
    if OtsikkoNode <> nil then
    begin
      if (LongRec(MaxKk).Lo in [1..12]) and (MaxKk <> LastKk)
      then MaxKkS := KkNro1.Items[LongRec(MaxKk).Lo] + ' '
      else MaxKkS := '';   // MaxKk tuntematon tai viimeinen kk
      if SuodatinOn.Checked then
      MaxKkS := MaxKkS + ' ' + SuodOtsikko.Text + ' ' + SuodatinText;  // listn projektiteksti ja -numero
      if VvNro1.Visible then MaxKkS := MaxKkS + IntToStr(LongRec(MaxKk).Hi);
      Otsikko('Tase ' + MaxKkS + ' ', Tase1.Items);
      Otsikko('Tuloslaskelma ' + MaxKkS + ' ', Tuloslaskelma1.Items);
      if (AccountNode <> nil) and (AccountNode.Count >= 3) then
      begin
        ApuNode1 := AccountNode.Item[2];
        ApuNode2 := nil;
        if VertailuOn and (AccountNode2 <> nil) and (AccountNode2.Count >= 3) then
        begin
          ApuNode2 := ApuNode1;
          ApuNode1 := AccountNode2.Item[2];
        end;
        { tuloslaskelma }
        Tuloslaskelma1.Items.Add(TulosTxt);
        Tuloslaskelma1.Items.Add('');
        BaseLevel := AccountNode.Item[2].Level;
        Miinus := AbsSum;
        ApuI := AddTulosAccount(ApuNode1, ApuNode2, Tuloslaskelma1.Items, ApuV);
        { vastaavaa }
        Tase1.Items.Add(VastaavaaTxt);
        Tase1.Items.Add('');
        BaseLevel := AccountNode.Item[0].Level;
        Miinus := False;
        ApuNode1 := AccountNode.Item[0];
        if ApuNode2 <> nil then
        begin
          ApuNode2 := ApuNode1;
          ApuNode1 := AccountNode2.Item[0];
        end;
        TaseSum := AddTulosAccount(ApuNode1, ApuNode2, Tase1.Items, ApuV);
        { vastattavaa }
        Tase1.Items.Add(VastattavaaTxt);
        Tase1.Items.Add('');
        BaseLevel := AccountNode.Item[1].Level;
        Miinus := AbsSum;
        Voitto := ApuI + Voitto2;
        ApuNode1 := AccountNode.Item[1];
        if ApuNode2 <> nil then
        begin
          ApuNode2 := ApuNode1;
          ApuNode1 := AccountNode2.Item[1];
        end;
        ApuI := AddTulosAccount(ApuNode1, ApuNode2, Tase1.Items, ApuV) - Voitto;
        if AbsSum then Dec(TaseSum, ApuI) else Inc(TaseSum, ApuI);
      end;
    end;
  end;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.TreeView1DblClick(Sender: TObject);
begin
  if (TTreeView(Sender).Selected <> nil) then
  begin
    TTreeView(Sender).Selected.Text :=
      InputBox('Muuta', 'Teksti', TTreeView(Sender).Selected.Text);
    if Sender = TreeView1 then
    begin
      DirtyFlag := $FFFF;
      Muuttunut := True;
    end;
  end;
end;

const
  { Pivkirjan ja pkirjan sivun otsake }
  ListaOts: array[1..2] of String = (
    'Tosite'+Tab+'Pivys'+Tab+'Tili/Selite'+Tab+Tab+Tab+'Debet'+Tab+'Kredit',            // Pivkirjan tulostus
    'Tili'+Tab+'Tosite'+Tab+'Selite'+Tab+'Pivys'+Tab+'Debet'+Tab+'Kredit'+Tab+'Saldo'); // Pkirja nytt/tulostus

  { pivkirjan ja pkirjan tabulaattoripaikat }
  TabPosV: array[0..8] of Integer = (0, 10, 250, 400, 550, 750, 870, 990, 1000);

var
  TabPosK, TabPos: array[1..2] of array[0..8] of Integer;

procedure TForm1.TabEditWidths;
var
  Ix: Integer;
begin
  with TabEditor1 do for Ix := 0 to 7 do ColWidths[Ix] :=
    MulDiv(TabPosK[TabId][Ix+1] - TabPosK[TabId][Ix], Paakirja1.ClientWidth, 1000);
end;

  { muutetaan tab-paikkoja }
procedure TForm1.TabPaikat1Click(Sender: TObject);
begin
  TabPaikat1.Checked := not TabPaikat1.Checked;
  if TabPaikat1.Checked and (TabId in [1..2]) then
  begin
    TabEditWidths(TabId);
    TabEditor1.RowHeights[1] := 16;
    TabEditor1.Show;
  end
  else if not TabPaikat1.Checked then TabEditor1.Hide;
end;

procedure TForm1.TabEditor1DrawCell(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  if (Tabid in [1..2]) and (Col = 7) and (Row = 1) then
  begin
    Rect.Left := 0;
    Rect.Right := Paakirja1.ClientWidth;
    DrawRow4(TabEditor1.Canvas, ListaOts[TabId], Rect);
  end;
end;

procedure TForm1.TabEditor1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  Ix, Iw: Integer;
begin
  Iw := 0;
  if TabId in [1..2]
  then with TabEditor1 do
  for Ix := 0 to 7 do
  begin
    Inc(Iw, ColWidths[Ix]);
    if ColWidths[Ix] <>
      MulDiv(TabPosK[TabId][Ix+1] - TabPosK[TabId][Ix], Paakirja1.ClientWidth, 1000)
    then
    begin
      if Ix < 7 then
      TabPosK[TabId][Ix+1] := MulDiv(Iw, 1000, Paakirja1.ClientWidth);
      TabEditWidths(TabId);
      TabPos[TabId][8] := 0; // aiheuttaa tabul.paikojen uudelleen laskemisen
      if TabId = 2 then Paakirja1.Repaint;
      Break;
    end;
  end;
end;

procedure TForm1.TabEditor1DblClick(Sender: TObject);
begin
  TabEditor1.Hide;
end;

procedure TForm1.TabEditor1SelectCell(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
begin
  CanSelect := False;
end;

const
  IniSectName: array[0..5] of String = ('Tilikartta',
    'Paivakirja', 'Paakirja', 'Tulos', 'Tase', 'Alv');

{ mrittelytietojen luku ini-tiedostosta }
procedure TForm1.ReadIni;
var
  Ix, Iy: Integer;
begin
  with TIniFile.Create(IniFileName) do
  begin
    for Ix := 0 to 5 do
    begin
      Marg[Ix][0] := ReadInteger(IniSectName[Ix], 'LeftMargin', 10);
      Marg[Ix][1] := ReadInteger(IniSectName[Ix], 'TopMargin', 10);
      Marg[Ix][2] := ReadInteger(IniSectName[Ix], 'RightMargin', 10);
      Marg[Ix][3] := ReadInteger(IniSectName[Ix], 'BottomMargin', 10);
      PrintFont[Ix] := ReadString(IniSectName[Ix], 'FontName', 'Arial');
      PrintSize[Ix] := ReadInteger(IniSectName[Ix], 'FontSize', 10);
      RowCap[Ix] := ReadInteger(IniSectName[Ix], 'RowSpace', 2);
      OtsRivit[Ix] := ReadInteger(IniSectName[Ix], 'OtsRows', 2);
    end;
    for Iy := 1 to 2 do
    for Ix := 0 to 8 do
    TabPosK[Iy][Ix] := ReadInteger(IniSectName[Iy], 'Tab'+IntToStr(Ix), TabPosV[Ix]);
    OpenDialog1.FileName := ReadString('Files', 'LastName', '');
    SaveDialog1.FileName := OpenDialog1.FileName;
    VatDropTxts.Clear;
    VatListTxts.Clear;
    for Ix := 0 to 13 do
    begin
      VatDropTxts.Add(ReadString('AlvDrop', VatTexts[Ix], VatDrops[Ix]));
      VatListTxts.Add(ReadString('AlvList', VatTexts[Ix], VatDrops[Ix]));
    end;
    VahVeroTxt := ReadString('AlvList', 'VahennVero', VahVeroTxt1);
    MaksVeroTxt := ReadString('AlvList', 'MaksetVero', MaksVeroTxt1);
    ValiSaldot := ReadInteger(IniSectName[2], 'ValiSaldot', 0) <> 0;
    Valisaldot1.Checked := ValiSaldot;
    SuodOtsikko.Text := ReadString('Texts', 'SuodOtsikko', SuodOtsikko.Text);
    Free;
  end;
end;

{ mrittelytietojen kirjoitus ini-tiedostoon }
procedure TForm1.WriteIni;
var
  Ix, Iy: Integer;
begin
  with TIniFile.Create(IniFileName) do
  begin
    for Ix := 0 to 5 do
    begin
      WriteInteger(IniSectName[Ix], 'LeftMargin', Marg[Ix][0]);
      WriteInteger(IniSectName[Ix], 'TopMargin', Marg[Ix][1]);
      WriteInteger(IniSectName[Ix], 'RightMargin', Marg[Ix][2]);
      WriteInteger(IniSectName[Ix], 'BottomMargin', Marg[Ix][3]);
      WriteString(IniSectName[Ix], 'FontName', PrintFont[Ix]);
      WriteInteger(IniSectName[Ix], 'FontSize', PrintSize[Ix]);
      WriteInteger(IniSectName[Ix], 'RowSpace', RowCap[Ix]);
      WriteInteger(IniSectName[Ix], 'OtsRows', OtsRivit[Ix]);
    end;
    for Iy := 1 to 2 do
    for Ix := 0 to 8 do
      WriteInteger(IniSectName[Iy], 'Tab'+IntToStr(Ix), TabPosK[Iy][Ix]);
    WriteString('Files', 'LastName', SaveDialog1.FileName);
    for Ix := 1 to 13 do
    begin
      if (VatDropTxts[Ix] <> VatDrops[Ix])
      or (ReadString('AlvDrop', VatTexts[Ix], #1) <> #1)
      then WriteString('AlvDrop', VatTexts[Ix], VatDropTxts[Ix]);
      if (VatListTxts[Ix] <> VatDrops[Ix])
      or (ReadString('AlvList', VatTexts[Ix], #1) <> #1)
      then WriteString('AlvList', VatTexts[Ix], VatListTxts[Ix]);
    end;
    WriteString('AlvList', 'VahennVero', VahVeroTxt);
    WriteString('AlvList', 'MaksetVero', MaksVeroTxt);
    WriteInteger(IniSectName[2], 'ValiSaldot', Ord(ValiSaldot));
    WriteString('Texts', 'SuodOtsikko', SuodOtsikko.Text);
    Free;
  end;
end;

{ raahataan nodea TreeView'ss }
procedure TForm1.TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := ((Source is TTreeView) and (Source = Tilikartta) or TreeSheet1.TabVisible);
end;

{ siirretn nodenpaikkaa TreeView'ss raahaamalla }
procedure TForm1.TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer);
var
  AnItem: TTreeNode;
  AttachMode: TNodeAttachMode;
  HT: THitTests;
begin
  if not (Source is TTreeView) or (TTreeView(Sender).Selected = nil) then Exit;
  HT := TTreeView(Sender).GetHitTestInfoAt(X, Y);
  AnItem := TTreeView(Sender).GetNodeAt(X, Y);
  if TTreeView(Sender).Selected = AnItem then Exit;
  if (HT - [htOnButton, htOnLabel, htOnIndent] <> HT) then
  begin
    if htOnLabel in HT then AttachMode := naAddChild
    else AttachMode := naInsert;
    TTreeView(Sender).Selected.MoveTo(AnItem, AttachMode);
    if Sender = TreeView1 then
    begin
      DirtyFlag := $FFFF;
      Muuttunut := True;
    end;  
  end;
end;

procedure TForm1.PaivakirjaDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  AItem, BItem: TTreeNode;
begin
  if not TreeSheet1.TabVisible or not (Source is TTreeView) or (Paivakirja.Selected = nil) then Exit;
  AItem := Paivakirja.GetNodeAt(X, Y);
  while AItem.Level > 1 do AItem := AItem.Parent;
  BItem := Paivakirja.Selected;
  while BItem.Level > 1 do BItem := BItem.Parent;
  if (BItem = nil) or (AItem = nil) or (BItem = AItem) then Exit;
  BItem := BItem.Data;
  AItem := AItem.Data;
  if (BItem = nil) or (AItem = nil) then Exit;
  BItem.MoveTo(AItem, naInsert);
  DirtyFlag := $FFFF;
  Muuttunut := True;
  OpenPaivakirja;
end;

{ haetaan, jos lytyy merkkijonon mukainen node TreeNode2:sta tai sen alinodeista }
function HaeNode(var TreeNode2: TTreeNode; const Jono: String): Boolean;
var
  Ix: Integer;
  TreeNode3: TTreeNode;
begin
  Result := StrLComp(PChar(Jono), PChar(TreeNode2.Text), Length(Jono)) = 0;
  if not Result and (TreeNode2.Count > 0) then
  begin
    TreeNode3 := TreeNode2;
    for Ix := 0 to TreeNode3.Count - 1 do
    begin
      TreeNode2 := TreeNode3.Item[Ix];
      if HaeNode(TreeNode2, Jono) then
      begin
        Result := True;
        Break;
      end;
    end;
  end;
end;

function TForm1.VatFromStr(const S: String; Ts: TStrings): Integer;
var
  Ix, Iy: Integer;
begin
  Result := 0;
  if Length(S) = 0 then Exit;
  Iy := 1;
  while not (S[Iy] in ['0'..'9']) and (Iy < (Length(S)+1)) do Inc(Iy);
  repeat Dec(Iy) until (Iy = 0) or (S[Iy] <> ' ');
  if Iy > 0 then
  for Ix := 1 to 15 do
  if StrLComp(PChar(S), PChar(Ts[Ix]), Iy) = 0 then
  begin
    Result := Ix;
    Break;
  end;
end;

procedure TForm1.TeeTili(SourNode, DestNode: TTreeNode);
var
  Ix, Iy, Iz, ApuI: Integer;
  ApuS: String;
begin
  Ix := Length(AccountTxt);
  ApuI := StrToNextInt(SourNode.Text, Ix);
  Iz := 0;
  Iy := 4;
  if ApuI > 0 then
  begin
    Destnode.DeleteChildren; { jos oli vat-rivi, se poistetaan }
    ApuS := IntToStr(ApuI) + ' ';
    if (SourNode.Count >= 2) and (Copy(SourNode.Item[1].Text, 1, 3) = 'vat')
    then Iz := VatFromStr(StrFromStr(SourNode.Item[1].Text, ' ', ' ', Iy), Form2.VatGrid1.Cols[0]);
  end
  else ApuS := '';
  DestNode.Text := ApuS + StrFromStr(SourNode.Text, '"', '"', Ix);
  DestNode.Data := SourNode;
  if Iz in [1..13] then
  begin
    ApuS := Form2.Alv1.Items[Iz];
    if (Iz in [1..3]) and (Length(SourNode.Item[1].Text) > Iy)
    then ApuS := ApuS +
      Format(' %.2f', [StrToNextInt(SourNode.Item[1].Text, Iy)/100]);
    Tilikartta.Items.AddChild(DestNode, ApuS);
  end;
end;

{ tilikartan kokoamista TreeNodesta }
procedure TForm1.TeeTilikartta(SourNode, DestNode: TTreeNode);
var
  Ix: Integer;
  ApuNode: TTreeNode;
begin
  Ix := Pos(AccountTxt, SourNode.Text);
  if Ix > 0 then
  begin
    ApuNode := Tilikartta.Items.AddChild(DestNode, '');
    TeeTili(SourNode, ApuNode);
  end
  else ApuNode := DestNode;
  if SourNode.Count > 0 then
  for Ix := 0 to SourNode.Count - 1
  do TeeTilikartta(SourNode[Ix], ApuNode);
end;

{ tilikartan teko }
procedure TForm1.OpenTilikartta;
begin
  DirtyFlag := DirtyFlag and $FFFE;
  Tilikartta.Items.Clear;
  if AccountNode <> nil then
  begin
    TeeTilikartta(AccountNode, nil);
    Tilikartta.Items[0].Text := 'TILIKARTTA';
    Tilikartta.FullExpand;
    Tilikartta.TopItem := Tilikartta.Items[0];
  end;
end;

{ haetaan Treenoden alinodeista Ix:st lhtien ensimminen lainausmerkein (") rajattu teksti }
function GetTreeText(TreeNode: TTreeNode; var Ix: Integer): String;
var
  Ia: Integer;
begin
  Result := '';
  while Ix < TreeNode.Count do
  begin
    Ia := Pos('"', TreeNode.Item[Ix].Text);
    if Ia = 1 then
    begin
      Result := StrFromStr(TreeNode.Item[Ix].Text, '"', '"', Ia);
      Break;
    end;
    Inc(Ix);
  end;
end;

{ haetaan Treenoden alinodeista Ix:st lhtien ensimminen money-tyyppinen luku }
function GetTreeMoney(TreeNode: TTreeNode; var Ix: Integer): Integer;
var
  Ia: Integer;
begin
  Result := 0;
  while Ix < TreeNode.Count do
  begin
    Ia := Pos(MoneyTxt, TreeNode.Item[Ix].Text);
    if Ia = 1 then
    begin
      Inc(Ia, Length(MoneyTxt));
      Result := StrToNextInt(TreeNode.Item[Ix].Text, Ia);
      Break;
    end;
    Inc(Ix);
  end;
end;

{ haetaan tilinumeroa vastaava tilin nimi }
function TForm1.GetAccountName(Txt: String): String;
var
  Ix: Integer;
begin
  Ix := StringIndexL(Accounts1, Copy(Txt, 1, NumLength(Txt)));
  OkFlag := Ix >= 0;
  if OkFlag then
  begin
    TiliNode := TTreeNode(Accounts1.Objects[Ix]);
    Result := Accounts1[Ix];
  end
  else Result := Txt + ' ???';
end;

{ pivkirjan kokoamista }
procedure TForm1.TeePaivakirja(SourNode, DestNode: TTreeNode);
var
  Ix, Iy, Iw, Iz, ApuI, ApuJ, ApuK: Integer;
  ApuS: String;
begin
  HakuOn := False;
  if SourNode.Count < 2 then Exit;
  Ix := Pos(EventTxt, SourNode.Text);
  if Ix > 0 then
  begin
    Inc(Ix, Length(EventTxt));
    ApuI := StrToNextInt(SourNode.Text, Ix);
    Ix := 0;
    ApuS := '[' + IntToStr(ApuI) + '] ' + GetTreeDate(SourNode, Ix) + ': ';
    if DestNode = nil
    then DestNode := Paivakirja.Items.AddChild(Paivakirja.Items[0], ApuS)
    else DestNode.Text := ApuS;
    DestNode.Data := SourNode;     // tositteen pnode
    ApuJ := 0;
    ApuK := 0;
    Iw := SourNode.Count - 1;
    if (Iw >= 0) and (SourNode[Iw].Count > 0) then
    for Iy := 0 to SourNode[Iw].Count - 1 do    // tositteen viennit
    begin
      Iz := 0;
      ApuI := GetTreeMoney(SourNode[Iw].Item[Iy], Iz);
      Inc(ApuK, ApuI);
      if ApuI > 0 then Inc(ApuJ, ApuI);
      ApuS := Format('%.2f', [ApuI/100]) + ': '
      + GetAccountName(SourNode[Iw].Item[Iy].Text);
      Paivakirja.Items.AddChild(DestNode, ApuS);
    end;
    ApuS := GetTreeText(SourNode, Ix);
    if Length(ApuS) > 0 then ApuS := ' - ' + ApuS;
    if ApuK <> 0 then ApuS := ' < V I R H E ' + ApuS;
    DestNode.Text := DestNode.Text + Format('%.2f', [ApuJ/100]) + ApuS;
  end;
end;

{ tehdn pivkirja }
procedure TForm1.OpenPaivakirja;
var
  ApuNode: TTreeNode;
  Ix: Integer;
begin
  DirtyFlag := DirtyFlag and $FFFD;
  Paivakirja.Items.Clear;
  if EventNode <> nil then
  begin
    ApuNode := Paivakirja.Items.AddChild(nil, 'PIVKIRJA');
    if EventNode.Count > 0 then
    for Ix := 0 to EventNode.Count - 1 do
    TeePaivaKirja(EventNode[Ix], nil);
    Paivakirja.TopItem := ApuNode;
    Paivakirja.Items[0].Expand(False);
  end;
end;

{ Vertaa tositteen pivmrteksti Pvm
  valittuun pivmralueeseen KkNro1 ja VvNro1 -alasvetolistoissa.
  Result = 0, jos ne on samat tai jos KkNro1 ja VvNro1 on valittu "koko kausi"
  Result < 0, jos tositteen pvm on ennen valittua
  Result > 0, jos tositteen pvm on valitun jlkeen }
function TForm1.VertPvm(const Pvm: String): Integer;
var
  Ia, Vv1, Kk1, Vv2, Kk2: Integer;
begin
  Ia := Length(Pvm);
  Vv1 := StrToPrevInt(Pvm, Ia);
  Kk1 := StrToPrevInt(Pvm, Ia);
  Kk2 := KkNro1.ItemIndex;
  if VvNro1.Visible and (VvNro1.ItemIndex > 0)
  then Vv2 := StrToIntDef(VvNro1.Text, Vv1)
  else Vv2 := Vv1;
  if Kk2 < 1 then Kk2 := Kk1        // koko kausi
  else if Kk2 in [13 .. 16] then
  begin   // neljnnesvuosittain
    Ia := (Kk2 - 13) * 3 + 1;
    Kk2 := Kk1;
    if Kk1 < Ia then Inc(Kk2)
    else if Kk1 > (Ia+2) then Dec(Kk2);
  end;
  Result := (12*Vv1+Kk1) - (12*Vv2+Kk2);
end;

{ tehdn pkirja }
procedure TForm1.TeePaakirja;
var
  Ix, Iy, Iz, Id, Ik, Iw, IDsum, IKsum, Kpl, KkVv1: Integer;
  ApuS: String;
  Alku, Avaus: Boolean;

  procedure AlkuSaldo;
  begin               { Alkusaldo nyttn }
    Alku := False;
    Paakirja1.Items.Add(Bold + Accounts1[Ix]
       +Tab+Tab+'Alkusaldo'+Tab+Tab+Tab+Tab + Format('%.2f', [Iw/100]));
  end;

begin
  DirtyFlag := DirtyFlag and $FFFB;
  Paakirja1.Items.Clear;
  if OtsikkoNode <> nil then
  begin
    Otsikko(Bold + 'Pkirja ' + ValKkS2 + ' ', Paakirja1.Items);
    Paakirja1.Items.Add(Under+ListaOts[2]);
    Paakirja1.Items.Add('');
    IDsum := 0;
    IKsum := 0;
    if Accounts1.Count > 0 then
    for Ix := 0 to Accounts1.Count - 1 do
    begin
      Alku := True;
      Id := 0;
      Ik := 0;
      Iw := 0;
      Kpl := 0;
      ApuS := Tab+Tab;
      if (Accounts1.Objects[Ix] <> nil)
      and (TTreeNode(Accounts1.Objects[Ix]).Data <> nil)
      then with TStringList(TTreeNode(Accounts1.Objects[Ix]).Data) do
      if Count > 0 then
      begin
        for Iy := 0 to Count - 1 do
        begin
          ApuS := Tab + Strings[Iy] + Tab;
          Avaus := Copy(ApuS, 1, 3) = (Tab+'0'+Tab);
          KkVv1 := VertPvm(Strings[Iy]);
          Iz := Integer(Objects[Iy]);
          if Alku and not Avaus and (KkVv1 >= 0) then AlkuSaldo;
          if not Alku and (KkVv1 > 0) then Break;
          Inc(Iw, Iz);
          if not Avaus and not Alku and (KkVv1 = 0) then  {avausvienti ei nytet eik lasketa Debet- ja Kredit-summiin}
          begin
            if Iz >= 0 then
            begin
              Inc(Id, Iz);
              ApuS := ApuS + Format('%.2f', [Iz/100]) + Tab;
            end
            else
            begin
              Inc(Ik, -Iz);
              ApuS := ApuS + Tab + Format('%.2f', [-Iz/100]);
            end;
            if ValiSaldot then ApuS := ApuS + Tab + Format('%.2f', [Iw/100]);
            Paakirja1.Items.Add(ApuS);
            Inc(Kpl);
          end;
        end;
      end;
      Inc(IDsum, Id);
      Inc(IKsum, Ik);
      { Loppusaldo nyttn }
      if (Kpl > 0) or (Iw <> 0) then
      begin
        if Kpl > 1 then
        Paakirja1.Items.Add(Tab+Tab+'Yhteens '+IntToStr(Kpl)+' kpl'+Tab+Tab
          + Format('%.2f', [Id/100]) + Tab + Format('%.2f', [Ik/100]));
        if Alku then AlkuSaldo;
        Paakirja1.Items.Add(Bold+Tab+Tab+'Loppusaldo'+Tab+Tab+Tab+Tab + Format('%.2f', [Iw/100]));
        Paakirja1.Items.Add('');
      end;
    end;
    Paakirja1.Items.Add(Bold+Tab+Tab+ ValKkS2 + ' yhteens'+Tab+Tab
        + Format('%.2f', [IDsum/100]) + Tab + Format('%.2f', [IKsum/100]));
  end;
end;

{ pkirjan teon aloitus, kysytn tilikuukautta tai koko kautta }
procedure TForm1.OpenPaakirja;
begin
  Paakirja1.Clear;
  KkBox1.Caption := 'Paakirja';
  KkBox1.Left := 200;
  TabEditor1.Hide;
  TabPaikat1.Checked := False;
  KkBox1Start;
end;

{ pkirjan ja alv-laskelman teko, pivkirjan printtaus }
procedure TForm1.Ok3Click(Sender: TObject);
begin
  ValKkS := KkNro1.Text;
  if VvNro1.Visible then ValKkS := ValKkS + ' ' + VvNro1.Text;
  ValKkS2 := ValKkS;
  if SuodatinOn.Checked then ValKkS2 := ValKkS2 + ' ' + SuodOtsikko.Text + ' ' + SuodatinText;
  KkBox1.Hide;
  case TabId of
    1: if KkBox1.Tag = 0 then PrintPvKirja else CopyPvList;
    2: TeePaakirja;
    5: TeeAlvLaskelma;
  end;
end;

{ pkirjan teon peruutus }
procedure TForm1.Cancel3Click(Sender: TObject);
begin
  KkBox1.Hide;
end;

{ Tab-tyyppisen sivuston sivun vaihto }
procedure TForm1.PageControl1Change(Sender: TObject);
begin
  if DirtyFlag and $8000 <> 0 then TeeAccountList1;   { pivitetn tililista }
  KkBox1.Hide;
  TilikarttaPrint1.Hide;
  TabEditor1.Hide;
 // EditBox1.Hide;
  TabPaikat1.Checked := False;
  HakuIx := 0;
  HakuOn := False;
  TabId := PageControl1.ActivePage.TabIndex;
  case TabId of
    0: begin       {tilikartta}
         Muokkaa1.Visible := False;
         Muokkaa2.Visible := True;
         Print1.Visible := False;
         Print2.Visible := False;
         Print3.Visible := False;
         Print4.Visible := True;
         TabPaikat1.Visible := False;
         ListItems := Accounts1;
         if DirtyFlag and 1 <> 0 then OpenTilikartta;
         HakuTreeView := Tilikartta;
         HakuListBox := nil;
       end;

    1: begin       {pivkirja}
         Muokkaa1.Visible := False;
         Muokkaa2.Visible := True;
         Print1.Visible := False;
         Print2.Visible := True;
         Print3.Visible := False;
         Print4.Visible := False;
         TabPaikat1.Visible := True;
         if DirtyFlag and 2 <> 0 then OpenPaivakirja;
         HakuTreeView := Paivakirja;
         HakuListBox := nil;
       end;

    2: begin       {pkirja}
         Muokkaa1.Visible := False;
         Muokkaa2.Visible := True;
         Print1.Visible := True;
         Print2.Visible := False;
         Print3.Visible := False;
         Print4.Visible := False;
         TabPaikat1.Visible := True;
         ListItems := Paakirja1.Items;
         if DirtyFlag and 4 <> 0 then OpenPaakirja;
         HakuTreeView := nil;
         HakuListBox := Paakirja1;
       end;

    3: begin       {tuloslaskelma}
         Muokkaa1.Visible := False;
         Muokkaa2.Visible := True;
         Print1.Visible := False;
         Print2.Visible := False;
         Print3.Visible := True;
         Print4.Visible := False;
         TabPaikat1.Visible := False;
         ListItems := Tuloslaskelma1.Items;
         if DirtyFlag and 8 <> 0 then OpenTulosTase(True);
         HakuTreeView := nil;
         HakuListBox := Tuloslaskelma1;
       end;

    4: begin       {tase}
         Muokkaa1.Visible := False;
         Muokkaa2.Visible := True;
         Print1.Visible := False;
         Print2.Visible := False;
         Print3.Visible := True;
         Print4.Visible := False;
         TabPaikat1.Visible := False;
         if DirtyFlag and 8 <> 0 then OpenTulosTase(True);
         ListItems := Tase1.Items;
         HakuTreeView := nil;
         HakuListBox := Tase1;
       end;

    5: begin       {alv-laskelma}
         Muokkaa1.Visible := False;
         Muokkaa2.Visible := True;
         Print1.Visible := False;
         Print2.Visible := False;
         Print3.Visible := True;
         Print4.Visible := False;
         TabPaikat1.Visible := False;
         if DirtyFlag and $10 <> 0 then OpenAlvLaskelma;
         ListItems := AlvSivu1.Items;
         HakuTreeView := nil;
         HakuListBox := AlvSivu1;
       end;

    6: begin       {treeview}
         Muokkaa1.Visible := True;
         Muokkaa2.Visible := False;
         Print1.Visible := False;
         Print2.Visible := False;
         Print3.Visible := False;
         Print4.Visible := False;
         HakuTreeView := TreeView1;
         HakuListBox := nil;
       end;

    7: begin       {vertailutiedot}
         Muokkaa1.Visible := False;
         Muokkaa2.Visible := False;
         Print1.Visible := False;
         Print2.Visible := False;
         Print3.Visible := False;
         Print4.Visible := False;
         HakuTreeView := TreeView2;
         HakuListBox := nil;
       end;

  end;
  if (TabId < 0) or (TabId > 5) then TabId := 3; // varmistus
end;

{ pkirjan, tuloslaskelman tai taseen tallennus }
procedure TForm1.Save2Click(Sender: TObject);
var
  NameS: String;
begin
  with SaveDialog1 do
  begin
    NameS := FileName;
    FileName := ExtractFileDir(FileName) + '\' + PageControl1.ActivePage.Caption + '.csv';
    FilterIndex := 3;
    DefaultExt := 'csv';
    if Execute then
      ListItems.SaveToFile(FileName);
    DefaultExt := '';
    FileName := NameS;
  end;
end;

{ tilikartan, pkirjan, tuloslaskelman, taseen tai alv-laskelman tulostus }
procedure TForm1.Print1Click(Sender: TObject);
var
  Iw, Ix, Iy, Iz, It, Ib, Ir, Iv, SivuNro: Integer;
  Rect: TRect;
  ApuS, TilitS: String;
  TOte, Mukana: Boolean;

  procedure PrintOneRow;
  begin
    Rect.Bottom := Rect.Top + Iz;
    if TabId in [1..2]
    then DrawRow4(Printer.Canvas, ApuS, Rect)
    else DrawRow(Printer.Canvas, ApuS, Rect);
    Rect.Top := Rect.Bottom;
  end;

  procedure PrintSivuNro;
  begin
    Inc(SivuNro);
    ApuS := ' ' +Tab+Tab+Tab+ 'Sivu ' + IntToStr(SivuNro);
    PrintOneRow;
    if TabId = 0 then
    begin // tilikarttaan otsikko
      ApuS := YritysNimi;
      PrintOneRow;
      ApuS := 'Tilikartta ' + KausiPvm(2, OtsikkoNode);
      PrintOneRow;
    end;
    Rect.Top := Rect.Top + Iz; // tyhj rivi
  end;

begin
  Inc(PrintKesken);
  if (TabId = 0) and (Kartta1.Checked)
  then Iw := Tilikartta.Items.Count
  else Iw := ListItems.Count;
  if Iw > 0 then
  begin
    Mukana := True;
    TOte := (TabId = 2) and (TControl(Sender).Tag = 1);
    if TOte then
    begin
      TilitS := InputBox('Tiliote', 'Anna tilinumero(t)', '');
      if Length(TilitS) = 0 then Exit;
    end;
    PrintDialog1.Copies := 0;
    if PrintDialog1.Execute then
    begin
      Printer.BeginDoc;
      with Printer.Canvas do
      begin
        Font.Assign(Paakirja1.Canvas.Font);
        Font.Name := PrintFont[TabId];
        Font.Size := PrintSize[TabId];
        Font.Color := clBlack;
        Pen.Assign(Paakirja1.Canvas.Pen);
        Iz := Font.Height;
        if Iz < 0 then Iz := -Iz else Inc(Iz, Iz div 4);
        Ix := Font.PixelsPerInch;
        Inc(Iz, MulDiv(RowCap[TabId], Ix, 100));  { rivien vlirako }
        It := MulDiv(Marg[TabId][1], Ix, 25);     { top margin}
        Ib := ClipRect.Bottom - MulDiv(Marg[TabId][3], Ix, 25) - Iz;  { bottom margin}
        Rect.Top := It;
        Iv := MulDiv(Marg[TabId][0], Ix, 25);     {left margin}
        Rect.Left := Iv;
        Rect.Right := ClipRect.Right - MulDiv(Marg[TabId][2], Ix, 25);  {right margin}
        SivuNro := 0;
        PrintSivuNro;
        for Iy := 0 to Iw - 1 do
        begin
          if TOte and (Iy = 2) then
          begin
            ApuS := Bold + 'TILIOTE, Tilinro: ' + TilitS;
            PrintOneRow;
          end;
          if (TabId = 0) and (Kartta1.Checked)  // tilikarttamuotoinen
          then ApuS := SpaceStr(2 * Tilikartta.Items[Iy].Level, ' ') + Tilikartta.Items[Iy].Text
          else ApuS := ListItems[Iy];
          if (TOte) and (Pos('Alkusaldo', ApuS) > 0) then
          Mukana := Pos(IntToStr(StrToFirstInt(ApuS, 2)), TilitS) > 0;
          if Mukana then PrintOneRow;
          if Rect.Bottom > Ib then
          begin
            if (TabId = 0) and (Luettelo1.Checked) then       // tililuettelo, 2 saraketta
            begin                   // sarake vaihtuu
              if Rect.Left = Iv
              then Rect.Left := (Rect.Left + Rect.Right) shr 1
              else Rect.Left := Iv;
            end;
            if (TabId > 0) or (Rect.Left = Iv) then
            begin
              Rect.Top := It;
              Printer.NewPage;
              PrintSivuNro;
              if (TabId > 0) and (OtsRivit[TabId] > 0) then
              for Ir := 0 to OtsRivit[TabId] - 1 do
              if Ir < ListItems.Count then
              begin
                ApuS := ListItems[Ir];
                PrintOneRow;
              end;
            end
            else Rect.Top := It + 4 * Iz;
          end;
        end;
      end;
      Printer.EndDoc;
    end;
  end;
  Dec(PrintKesken);
end;

{ marginaalit-menun tekstien pivitys }
procedure TForm1.Marginaalit1Click(Sender: TObject);
begin
  Left1.Caption := 'Vas = ' + IntToStr(Marg[TabId][0]) + ' mm';
  Top1.Caption := 'Yl = ' + IntToStr(Marg[TabId][1]) + ' mm';
  Right1.Caption := 'Oik = ' + IntToStr(Marg[TabId][2]) + ' mm';
  Bottom1.Caption := 'Ala = ' + IntToStr(Marg[TabId][3]) + ' mm';
  RowCap1.Caption := 'Vli = ' + IntToStr(RowCap[TabId]) + ' mm';
  Otsikkorivit1.Caption := 'Ots.rivit = ' + IntToStr(OtsRivit[TabId]);
end;

{ pkirjan, tuloslaskelman tai taseen kopiointi leikepydlle }
procedure TForm1.Copy1Click(Sender: TObject);
begin
  if TabId = 1 then
  begin
    KkBox1.Caption := 'Pivkirjan tulostus';
    KkBox1.Left := 130;
    KkBox1.Tag := 1;
    TabEditor1.Hide;
    TabPaikat1.Checked := False;
    KkBox1Start;
  end
  else
  CopyList;
end;

procedure TForm1.CopyPvList;
begin
  ListPvKirja;
  CopyList;
  ListItems.Free;
  ListItems := Paakirja1.Items;
end;

procedure TForm1.CopyList;
begin
  if ListItems.Count > 0 then
  with TClipBoard.Create do
  begin
    SetTextBuf(PChar(ListItems.Text));
    Free;
  end;
end;

{ marginaalimenun Left-, Top-, Right- ja Bottom-lukujen muutos }
procedure TForm1.Left1Click(Sender: TObject);
begin
  with TControl(Sender) do
  if Tag in [0..3] then
  Marg[TabId][Tag] :=  StrToIntDef(InputBox('Print Page Marginal', MargTxt[Tag],
              IntToStr(Marg[TabId][Tag])), Marg[TabId][Tag]);
end;

{ marginaalimenun rivivlyksen muutos }
procedure TForm1.RowCap1Click(Sender: TObject);
begin
  RowCap[TabId] :=  StrToIntDef(InputBox('Printtausasetus', 'Rivien vlirako',
              IntToStr(RowCap[TabId])), RowCap[TabId]);
end;

{ sivuasetuksessa otsikkorivien lukumrn muutos }
procedure TForm1.Otsikkorivit1Click(Sender: TObject);
begin
  OtsRivit[TabId] :=  StrToIntDef(InputBox('Printtausasetus', 'Otsikkorivit kpl',
              IntToStr(OtsRivit[TabId])), OtsRivit[TabId]);
end;

{ sivuasetuksessa fontin muutos }
procedure TForm1.Font1Click(Sender: TObject);
begin
  with FontDialog1 do
  begin
    Font.Name := PrintFont[TabId];
    Font.Size := PrintSize[TabId];
    if Execute then
    begin
      PrintFont[TabId] := Font.Name;
      PrintSize[TabId] := Font.Size;
    end;
  end;
end;

{procedure TForm2.FormResize(Sender: TObject);
begin
  ListBoxP.Repaint;
end;}

{ Tab-tyyppisten sivujen hiiren oikean nppimen menu }
procedure TForm1.PageControl1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then PopupMenu1.Popup(X + Left, Y + Top);
end;

{ pkirjan kustomoitu rivin muotoilu
  kytetn mys pivkirjan tulostuksessa}
procedure TForm1.DrawRow4(Canvas: TCanvas; ApuS: String; Rect: TRect);
var
  Ix, Iy, Iz, Iw, Iu: Integer;
  ApuS2: String;
begin
  if (TabId in [1..2]) and (Length(ApuS) > 0) then
  with Canvas do
  begin
    Iw := Rect.Right - Rect.Left;
    if TabPos[TabId][8] <> Iw then
      for Ix := 0 to 8 do TabPos[TabId][Ix] := Rect.Left + MulDiv(Iw, TabPosK[TabId][Ix], 1000);
    Iy := 2;
    if ApuS[1] = Under then Font.Style := [fsBold, fsUnderline]
    else if ApuS[1] = Bold then Font.Style := [fsBold]
    else
    begin
      Font.Style := [];
      Iy := 1;
    end;
    Iw := 1;
    while Iy < Length(ApuS) do
    begin
      Iz := Iy;
      while (Iy <= Length(ApuS)) and (ApuS[Iy] <> Tab) do Inc(Iy);
      if Iy > Iz then
      begin
        ApuS2 := Copy(ApuS, Iz, Iy - Iz);
        if Iw > 3
        then Iu := TabPos[TabId][Iw] - TextWidth(ApuS2)
        else Iu := TabPos[TabId][Iw];
        Rect.Left := Iu - TextWidth('0');    // estetn edellisen kentn meno plle
        if Rect.Left < 0 then Rect.Left := 0;
        TextRect(Rect, Iu, Rect.Top, ApuS2);
      end;
      Inc(Iy);
      if Iw < 7 then Inc(Iw);
    end;
  end;
end;

(*
        // estetn liian pitkn selityksen nkyminen kokonaan
        if Iw = 3 then
        begin
          Iu := TabPos[TabId][Iw];
          ApuRect := Rect;
          ApuRect.Left := Iu;
          ApuRect.Right := TabPos[TabId][Iw+1] - 8;
          TextRect(ApuRect, Iu, Rect.Top, ApuS2);
        end
        else
        begin
*)

{ pkirjan nytn kustomointi }
procedure TForm1.Paakirja1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  ApuS: String;
begin
  with TListBox(Control).Canvas do
  begin
    FillRect(Rect);
    ApuS := TListBox(Control).Items[Index];
    DrawRow4(TListBox(Control).Canvas, ApuS, Rect);
  end;
end;

{ tuloslaskelman, taseen ja alv-laskelman kustomoitu rivin muotoilu }
procedure TForm1.DrawRow(Canvas: TCanvas; ApuS: String; Rect: TRect);
var
  Ix, Iv, Iw: Integer;
  Cx: Char;
  ApuT: String;
begin
  Iv := Rect.Left;
  if Length(ApuS) > 0 then with Canvas do
  begin
    if TabId = 6 then
    begin    // kytss treeviewin printtauksessa
      Iw := (Rect.Right - Rect.Left) div 32;
      repeat
        Ix := Pos(Tab, ApuS);
        if Ix > 0 then Delete(ApuS, Ix, 1);
        Inc(Iv, Iw);
      until (Ix <= 0) or (Iv > (24 * Iw));
      TextOut(Iv, Rect.Top, ApuS);
    end
    else
    begin
      Cx := ApuS[1]; // eka merkki mr bold ja underline stylet
      { spacet muutetaan kiintemittaisiksi }
      Ix := 1;
      while ApuS[Ix] = ' ' do Inc(Ix);  // lasketaan spacet
      Iv := Iv + MulDiv(Ix - 1, Rect.Right - Rect.Left, 64);  // vasen reuna
      if Ix > 1 then Delete(ApuS, 1, Ix - 1);
      if Cx = ' ' then Font.Style := [] else Font.Style := [fsBold];
      Ix := Pos(Tab, ApuS);
      if Ix > 0 then
      begin
        if Cx = 'Y'        // Yht-rivi (Cx <> ' ') and (Cx <> Tab)
        then Font.Style := [fsBold, fsUnderline];
        if Ix > 1 then
        TextOut(Iv + 10, Rect.Top, Copy(ApuS, 1, Ix - 1));
        ApuS := Copy(ApuS, Ix + 1, Length(ApuS) - Ix);
        if (TabId in [3..4]) and VertailuOn then
        begin
          Iw := TextWidth('0') * 15;
          Ix := Pos(Tab, ApuS);
          if Ix > 0 then
          begin
            ApuT := Copy(ApuS, Ix + 1, Length(ApuS) - Ix);
            ApuS := Copy(ApuS, 1, Ix - 1);
          end
          else ApuT := '';
          TextOut(Rect.Right - TextWidth(ApuS) - Iw - 10, Rect.Top, ApuS);
          if Length(ApuT) > 0 then
          TextOut(Rect.Right - TextWidth(ApuT) - 10, Rect.Top, ApuT);
        end
        else TextOut(Rect.Right - TextWidth(ApuS) - 10, Rect.Top, ApuS);
      end
      else TextOut(Iv + 10, Rect.Top, ApuS);
    end;
  end;
end;

{ pivkirjan, tuloslaskelman ja taseen nytn kustomointi }
procedure TForm1.TulosLaskelma1DrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  ApuS: String;
begin
  with TListBox(Control).Canvas do
  begin
    FillRect(Rect);
    ApuS := TListBox(Control).Items[Index];
    DrawRow(TListBox(Control).Canvas, ApuS, Rect);
  end;
end;

{ tositteen editointia, aloitetaan uusi tosite }
procedure TForm1.UusiTosite1Click(Sender: TObject);
var
  Ix, Iy: Integer;
  ApuNode: TTreeNode;
begin
  EditNode := nil;
  Ix := 1;
  Iy := 0;
  if Paivakirja.Items[0].Count > 0 then
  begin
    ApuNode := Paivakirja.Items[0].Item[Paivakirja.Items[0].Count-1];
    Iy := StrToIntDef(StrFromStr(ApuNode.Text, '[', ']', Ix), -1) + 1;
    Form2.Pvm1.Text := StrFromStr(ApuNode.Text, ' ', ':', Ix);
  end;
  with Form2 do
  if (TMenuItem(Sender).Tag = 0)
  or (Paivakirja.Selected = nil) then
  begin
    ShowMe(EditBox1);
    Caption := 'Uusi tosite';
    TosNro1.Text := IntToStr(Iy);
    Selite1.Text := '';
    with EditGrid1 do
    for Ix := 0 to ColCount - 1 do
    for Iy := 1 to RowCount - 1 do
      Cells[Ix, Iy] := '';
    EditGrid1.RowCount := 2;
    MaxTiliRow := 0;
    EditBoxStart(True);
  end
  else
  begin
    PaivakirjaDblClick(Sender);
    TosNro1.Text := IntToStr(Iy);
    EditNode := nil;
  end;;
end;

{ Poistetaan viimeinen tosite }
procedure TForm1.PoistaViimeinen1Click(Sender: TObject);
begin
  if Paivakirja.Items.Count > 0
  then
  with Paivakirja.Items[0] do
  if Count > 0 then
  begin
    if (Item[Count-1].Data <> nil) then
    TTreeNode(Item[Count-1].Data).Delete;
    Item[Count-1].Delete;
    Muuttunut := True;
    DirtyFlag := $FFFF;
  end;
end;

{ muunnetn 01.02.1234 -tyyppinen pivys muotoon 1234 02 01}
function PvmToText(const PvmStr: String): String;
var
  Ix, Pv, Kk: Integer;
begin
  Ix := 1;
  Pv := StrToNextInt(PvmStr, Ix);
  Kk := StrToNextInt(PvmStr, Ix);
  Result := IntToStr(StrToNextInt(PvmStr, Ix)) + ' ' +
    IntToStr(Kk) + ' ' + IntToStr(Pv);
end;

function TForm1.TiliVuodet(const PvmStr1, PvmStr2: String): Boolean;
var
  Ix, I1, I2: Integer;
begin
  Result := False;
  Ix := 1;
  StrToNextInt(PvmStr1, Ix);             // aloitus-pvm
  StrToNextInt(PvmStr1, Ix);             // aloitus-kk
  I1 := StrToNextInt(PvmStr1, Ix);       // aloitus-vv
  Ix := 1;
  StrToNextInt(PvmStr2, Ix);                         // pttymis-pv
  LongRec(LastKk).Lo := StrToNextInt(PvmStr2, Ix);   // pttymis-kk
  I2 := StrToNextInt(PvmStr2, Ix);                   // pttymis-vv
  LongRec(LastKk).Hi := I2;
  if (I1 > 0) and (I2 > 0) and (I2 >= I1) and ((I2 - I1) < 10) then
  begin
    if I2 > I1 then
    begin
      VvNro1.Items.Clear;
      VvNro1.Items.Add(IntToStr(I1) + '-' + IntToStr(I2));
      for Ix := I1 to I2 do VvNro1.Items.Add(IntToStr(Ix));
      KkNro1.Top := 16;
      VvNro1.Text := VvNro1.Items[0];
      VvNro1.Visible := True;
    end
    else
    begin
      KkNro1.Top := 32;
      VvNro1.Visible := False;
    end;
    Result := True;
  end;
end;

{ tositteen editoinnin loppuessa siirretn tiedot pivkirjaan }
procedure TForm1.GetTosite;
var
  Ix, Iy: Integer;
  ApuNode, ApuNode2: TTreeNode;
  UusiTos: Boolean;
begin
  if EventNode = nil then Exit;     // varmistus
  UusiTos := EditNode = nil;
  if UusiTos then
  begin    { uusi tosite }
    EditNode := Paivakirja.Items.AddChild(Paivakirja.Items[0], ''); { uusi }
    EditNode.Data := TreeView1.Items.AddChild(EventNode, 'event ' + Form2.TosNro1.Text);
  end
  else
  begin    { tositteen muutos }
    EditNode.DeleteChildren;
    if EditNode.Data <> nil then with TTreeNode(EditNode.Data) do
    begin
      Text := 'event ' + Form2.TosNro1.Text;
      DeleteChildren;
    end;
  end;
  if (EditNode.Data = nil) or (MaxTiliRow < 1) then Exit;  // varmistus
  { tehdn viennit ptaulukkoon, josta sitten siirretn pivkirjaan }
  ApuNode := EditNode.Data;
  TreeView1.Items.AddChild(ApuNode, 'date ' + PvmToText(Form2.Pvm1.Text));
  TreeView1.Items.AddChild(ApuNode, '"' + Form2.Selite1.Text + '"');
  ApuNode := TreeView1.Items.AddChild(ApuNode, '');
  with Form2 do
  for Ix := 1 to MaxTiliRow do
  begin
    ApuNode2 := TreeView1.Items.AddChild(ApuNode, Copy(EditGrid1.Cells[0, Ix], 1, NumLength(EditGrid1.Cells[0, Ix])));
    Iy := SumTxtToInt(EditGrid1.Cells[1, Ix] + EditGrid1.Cells[2, Ix]);
    if Length(EditGrid1.Cells[2, Ix]) > 2 then Iy := -Iy;
    TreeView1.Items.AddChild(ApuNode2, 'money ' + IntToStr(Iy));
  end;
  { siirretn pivkirjaan }
  TeePaivakirja(EditNode.Data, EditNode);
  Muuttunut := True;
  DirtyFlag := $FFFF;
  if UusiTos then
  UusiTosite1Click(Self);
end;

{ tositteen editoinnin alku kaksoisklikkaamalla }
procedure TForm1.PaivakirjaDblClick(Sender: TObject);
begin
  if (Paivakirja.Selected <> nil) then
  begin
    EditNode := Paivakirja.Selected;
    while EditNode.Level > 1 do EditNode := EditNode.Parent;
    Form2.ShowMe(Form2.EditBox1);
    Form2.Caption := 'Muokkaa tositetta';
    Form2.PutTosite;
  end;
end;

{ uusi kirjanpito tai tietojen muutos }
procedure TForm1.Uusi1Click(Sender: TObject);
begin
  if Talteenko <> mrCancel then
  begin
    UusiKausi := TMenuItem(Sender).Tag = 1;
    KaudenVaihto := TMenuItem(Sender).Tag = 2;
    if (TMenuItem(Sender).Tag = 2) then
    begin
      TeeAccountList1;
      if (AccountNode = nil) or (EventNode = nil) then
      begin
        ShowMessage('Avaa ensin edellinen tilikausi!');
        Exit;
      end;
      OpenTulosTase(False);
      DirtyFlag := $FFFF;
      if (TaseSum <> 0) and
      (MessageDlg('Summien ero ' + Format('%.2f', [TaseSum/100]) +
       #13#10'Mahdollisesti voitto kirjaamatta taseeseen'#13#10'Jatketaanko?' ,
       mtError, mbOkCancel, 0) <> mrOk)
      then Exit;
    end;
    if UusiKausi
    then Perustiedot1.Caption := 'Uusi tilikausi'
    else Perustiedot1.Caption := 'Muuta tietoja';
    YritNimi1.Text := YritysNimi;
    UusiPvm1.Text := KausiPvm(1, OtsikkoNode);
    UusiPvm2.Text := KausiPvm(2, OtsikkoNode);
 {   Ix := AlvKausiVal(OtsikkoNode);
    if Ix = 3
    then Alv3kk.Checked := True
    else if Ix = 12
    then Alv1v.Checked := True
    else Alv1kk.Checked := True;  }
    TabEditor1.Hide;
    TabPaikat1.Checked := False;
    Perustiedot1.Show;
  end;
end;

{ peruutetaan uuden kirjanpidon aloitus tai tietojen muutos}
procedure TForm1.Button2Click(Sender: TObject);
begin
  Perustiedot1.Hide;
end;

{ Uusi tilikausi, tehdn avausviennit }
procedure TForm1.TilikaudenVaihto;
var
  Ix, Iy, Iz, Iw: Integer;
  ApuNode: TTreeNode;
  ApuS: String;
begin
  OpenTulosTase(False);
  EventNode.DeleteChildren;
  ApuNode := TeeAvausNode;
  Iw := 0;
  with Tase1.Items do
  if Count > 1 then
  for Ix := 0 to Count - 1 do
  begin
    // etsitn tilinumeroja
    Iy := 1;
    while (Iy < Length(Strings[Ix])) and (Strings[Ix][Iy] <= ' ') do Inc(Iy);
    if Iy > 1 then
    begin
      Dec(Iy);
      ApuS := StrFromStr(Strings[Ix], ' ', ' ', Iy);
      if (Length(ApuS) = NumLength(ApuS)) and (StringIndexL(Accounts1, ApuS) >= 0) then
      begin
        // etsitn summa
        Iz := Length(Strings[Ix]);
        while (Iz > Iy) and (Strings[Ix][Iz] in [',', '-', '0'..'9']) do Dec(Iz);
        if Iz < Length(Strings[Ix]) then
        begin
          Iy := SumTxtToInt(Copy(Strings[Ix], Iz+1,
            Length(Strings[Ix])-Iz));
          Inc(Iw, Iy);
          if Iy <> 0 then
          TreeView1.Items.AddChild(TreeView1.Items.AddChild(ApuNode, ApuS),
            MoneyTxt + ' ' + IntToStr(Iy));
        end;
      end;
    end;
  end;
  SaveDialog1.FileName := '';
  if Iw <> 0 then ShowMessage('Vientien ero ' + Format('%.2f', [Iw/100]));
  Muuttunut := True;
  DirtyFlag := $FFFF;
end;


function TForm1.TeeAvausNode: TTreeNode;
var
  ApuNode: TTreeNode;
begin
  ApuNode := TreeView1.Items.AddChild(EventNode, 'event 0');
  TreeView1.Items.AddChild(ApuNode, 'date ' + PvmToText(UusiPvm1.Text));
  TreeView1.Items.AddChild(ApuNode, '"Tilinavaus"');
  Result := TreeView1.Items.AddChild(ApuNode, '');
end;

{ uusi kirjanpito tai tietojen muutos; perustiedot annettu }
procedure TForm1.Button1Click(Sender: TObject);
var
  ApuNode, ApuNode2: TTreeNode;
begin
  if not TiliVuodet(UusiPvm1.Text, UusiPvm2.Text) then
  begin
    ShowMessage('Virheelliset pivykset');
    Exit;
  end;
  Perustiedot1.Hide;
  if not UusiKausi then
  begin
    if OtsikkoNode <> nil then
    begin
      OtsikkoNode.Text := 'fiscal-year "' + YritNimi1.Text + '"';
      if OtsikkoNode.Count >= 2 then
      begin
        OtsikkoNode[0].Text := 'date ' + PvmToText(UusiPvm1.Text);
        OtsikkoNode[1].Text := 'date ' + PvmToText(UusiPvm2.Text);
      end;
    end;
    if KaudenVaihto then TiliKaudenVaihto;
    Muuttunut := True;
  end
  else
  begin
    TreeView1.Items.Clear;
    ApuNode := TreeView1.Items.AddFirst(nil, 'identity "Tappio" version "versio 0.22" finances');
    ApuNode := TreeView1.Items.AddChild(ApuNode, 'fiscal-year "' + YritNimi1.Text + '"');
    TreeView1.Items.AddChild(ApuNode, 'date ' + PvmToText(UusiPvm1.Text));
    TreeView1.Items.AddChild(ApuNode, 'date ' + PvmToText(UusiPvm2.Text));
    ApuNode2 := TreeView1.Items.AddChild(ApuNode, 'account-map');
    TreeView1.Items.AddChild(ApuNode2, 'account -1 "V A S T A A V A A"');
    TreeView1.Items.AddChild(ApuNode2, 'account -1 "V A S T A T T A V A A"');
    TreeView1.Items.AddChild(ApuNode2, 'account -1 "T U L O S"');
    EventNode := TreeView1.Items.AddChild(ApuNode, '');
    TeeAvausNode;
    Muuttunut := False;
    PageControl1.Show;
  end;
  DirtyFlag := $FFFF;
  TeeAccountList1;
  SetCaption;
  PageControl1.ActivePage := PaivaSheet2;
  PageControl1Change(Sender);
end;

function OnTiliNro(var Ix: Integer; const S: String): Boolean;
var
  Iy: Integer;
begin
  Iy := 1;
  Ix := StrToNextInt(S, Iy);
  Result := (Ix > 0); //(Ix >= 1000) and (Ix < 10000);
end;

{ tilikartan muutos }
procedure TForm1.TilikarttaDblClick(Sender: TObject);
var
  Ix, Iy: Integer;
begin
  if (Tilikartta.Selected <> nil) then
  begin
    UusiAlaTili := False;
    EditNode := Tilikartta.Selected;
    Ix := 0;
    { Jos on klikattu alv-nodea, siirrytn tilinodeen }
    if not OnTiliNro(Ix, EditNode.Text) and (EditNode.Count = 0)
    and (EditNode.Parent <> nil) and OnTiliNro(Ix, EditNode.Parent.Text)
    then EditNode := EditNode.Parent;
    with Form2 do
    begin
      ShowMe(TiliEditBox1);
      Caption := 'Muokataan tili';
      { tilinumero }
      if Ix > 0 then TiliNro2.Text := IntToStr(Ix) else TiliNro2.Text := '';
      Ix := 0;
      { onko alv-node }
      if EditNode.Count > 0 then Ix := VatFromStr(EditNode.Item[0].Text, Alv1.Items);
      Alv1.ItemIndex := Ix;
      { alv-% }
      if Ix in [1..3]
      then
      begin
        Iy := Length(Alv1.Items[Ix]);
        AlvPros1.Text := StrFromStr(EditNode.Item[0].Text, ' ', ' ', Iy);
      end
      else AlvPros1.Text := '';
     { tilin nimi }
      Iy := Length(TiliNro2.Text);
      if Iy = 0
      then TiliNimi2.Text := EditNode.Text
      else TiliNimi2.Text := StrFromStr(EditNode.Text, ' ', #0, Iy);
    end;
  end;
end;

{ uusi alatili }
procedure TForm1.UusiAlatili2Click(Sender: TObject);
begin
  if (Tilikartta.Selected <> nil) then
  with Form2 do
  begin
    UusiAlaTili := True;
    EditNode := Tilikartta.Selected;
    Caption := 'Uusi alatili otsikolle ' + EditNode.Text;
    TiliNro2.Text := '';
    Alv1.ItemIndex := 0;
    TiliNimi2.Text := '';
    ShowMe(TiliEditBox1);
  end;
end;


{ yleinen popup-menun kynnistys }
procedure TForm1.ShowPopup(Cntrl: TControl; PopupA: TPopupMenu; ApuP: TPoint);
begin
  ApuP := Cntrl.ClientToScreen(ApuP);
  PopupA.Popup(ApuP.X, ApuP.Y);
end;

{ pivkirja; hiiren oikean nppimen popup-menu }
procedure TForm1.PaivakirjaMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbRight) then
  begin
    Paivakirja.Selected := Paivakirja.GetNodeAt(X, Y);
    if not Form2.Visible
    then ShowPopup(Paivakirja, PaivakirjaMenu1, Point(X, Y));
  end;
end;

{ tilikartta: hiiren oikean nppimen popup-menu }
procedure TForm1.TilikarttaMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbRight) then
  begin
    Tilikartta.Selected := Tilikartta.GetNodeAt(X, Y);
    if not Form2.Visible
    and (Tilikartta.Selected <> nil)
    and ((Tilikartta.Selected.Parent = nil) or
       (StrToFirstInt(Tilikartta.Selected.Parent.Text, 1) = 0))
    then ShowPopup(Tilikartta, TilikarttaMenu1, Point(X, Y));
  end;
end;

{ treeview: hiiren oikean nppimen popup-menu }
procedure TForm1.TreeView1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbRight)
  then ShowPopup(TTreeView(Sender), TreeMenu2, Point(X, Y));
end;

{ poistetaan tili }
procedure TForm1.MenuItem3Click(Sender: TObject);
begin
  if (Tilikartta.Selected <> nil) and (Tilikartta.Selected.Data <> nil) then
  begin
    if TTreeNode(Tilikartta.Selected.Data).Data <> nil
    then ShowMessage('Tili ei voi poistaa,'#13#10'koska sill on vientej')
    else
    begin
      TTreeNode(Tilikartta.Selected.Data).Delete;
      Tilikartta.Selected.Delete;
      Muuttunut := True;
      DirtyFlag := $FFFF;
    end;
  end;
end;

{ Tehdn kaikista tilinumeroista tililista Accounts1 tai Accounts2.
  Accounts on aakkostettu tilinumeron mukaan.
  Lisksi tehdn Accounts1:n tilinimien mukaan aakkostettu AccountNames.
  Samalla tehdn tilikohtainen vientilista.
  AccountNames: TStringList:
  AccountNames.Strings[] = tilinimi + numero.
  Accounts: TStringList:
  Accounts.Strings[] = tilinumero + nimi; Accounts.Objects[] = tilin node.
  Tilin node on TTreeNode, jonka Data osoittaa StringList-tyyppiseen listaan:
  (Data).Strings[] = Tositenro + selite + pivys; (Data).Objects[] = vientisumma.
}
procedure TForm1.TeeTiliLista(Node: TTreeNode; Accounts: TStringList);
var
  Ix, Iy, Iz: Integer;
  Sx, Sy: String;
begin
//  MaxKk := 0;
  if (Length(Node.Text) >= 5) then
  begin
    { onko 'account'-teksti? }
    if StrLComp(PChar(Node.Text), PChar(AccountTxt), Length(AccountTxt)) = 0 then
    begin
      Iy := Length(AccountTxt);                      // account -tekstin pern
      Sx := StrFromStr(Node.Text, ' ', ' ', Iy);     // tilinumero
      Ix := StrToIntDef(Sx, 0);
      if (Ix > 0) then // (Ix >= 1000) and (Ix < 10000) then
      begin
        Sy := StrFromStr(Node.Text, '"', '"', Iy);
        Iz := Accounts.AddObject(Sx + ' ' + Sy, Node);
        if Accounts = Accounts1 then AccountNames.Add(Sy + ' ' + Sx);
        if Node.Data <> nil then
        begin
          TStringList(Node.Data).Free;
          Node.Data := nil;
        end;
        Exit;
      end;
    end
    else if StrLComp(PChar(Node.Text), PChar(EventTxt), Length(EventTxt)) = 0 then
    begin
      Iy := Length(EventTxt);
      Ix := StrToNextInt(Node.Text, Iy);                // tositenumero
      if (Node.Count >= 3) and (Node[2].Count > 0) then
      begin
        Iy := 1;
        Sx := Trim(StrFromStr(Node[1].Text, '"', '"', Iy));
        if SuodatinOn.Checked
        and not ((Length(Sx) >= Length(SuodatinText)) and (Copy(Sx, 1, Length(SuodatinText)) = SuodatinText))
        then Exit;
        Iz := 0;
        Sx := IntToStr(Ix) + Tab + Sx + Tab + GetTreeDate(Node, Iz);
        for Ix := 0 to Node[2].Count - 1 do
        if Node[2][Ix].Count > 0 then
        begin
          Iy := 1;
          Iz := StrToNextInt(Node[2][Ix].Text, Iy);         // tilinumero
          Iz := StringIndexL(Accounts, IntToStr(Iz));       // tilinumeron index listassa
          if (Iz >= 0) and (Accounts.Objects[Iz] <> nil) and
            (StrLComp(PChar(Node[2][Ix][0].Text), PChar(MoneyTxt), Length(MoneyTxt)) = 0) then
          begin  // money-teksti lytyi
            Iy := Length(MoneyTxt);
            Iy := StrToNextInt(Node[2][Ix][0].Text, Iy);    // vientisumma
            if TTreeNode(Accounts.Objects[Iz]).Data = nil
            then TTreeNode(Accounts.Objects[Iz]).Data := TStringList.Create;
            TStringList(TTreeNode(Accounts.Objects[Iz]).Data).AddObject(Sx, Pointer(Iy));
          end;
        end;
      end;
      Exit;
    end;
  end;
  if Node.Count > 0 then
  for Ix := 0 to Node.Count - 1 do TeeTiliLista(Node[Ix], Accounts);
end;

procedure TForm1.TeeAccountList1;
begin
  DirtyFlag := DirtyFlag and $7FFF;
  Accounts1.Clear;
  AccountNames.Clear;
  MaxKk := 0;
  if TreeView1.Items.Count > 0 then
  begin
    TeeTiliLista(TreeView1.Items[0], Accounts1);
    OtsikkoNode := FindTreeKey(FiscalYearTxt, TreeView1.Items[0]);
    if OtsikkoNode <> nil
    then AccountNode := FindTreeKey(AccountMapTxt, OtsikkoNode)
    else AccountNode := nil;
    if AccountNode <> nil then
    begin
      if OtsikkoNode.Count > (AccountNode.Index + 1)
      then EventNode := OtsikkoNode[AccountNode.Index + 1]
      else EventNode := TreeView1.Items.AddChild(OtsikkoNode, '');
    end
    else EventNode := nil;
  end;
end;

procedure TForm1.TeeAccountList2;
begin
  Accounts2.Clear;
  if TreeView2.Items.Count > 0 then
  begin
    TeeTiliLista(TreeView2.Items[0], Accounts2);
    OtsikkoNode2 := FindTreeKey(FiscalYearTxt, TreeView2.Items[0]);
    if OtsikkoNode2 <> nil
    then AccountNode2 := FindTreeKey(AccountMapTxt, OtsikkoNode2)
    else AccountNode2 := nil;
    if AccountNode2 <> nil then
    begin
      if OtsikkoNode2.Count > (AccountNode2.Index + 1)
      then EventNode2 := OtsikkoNode[AccountNode2.Index + 1]
      else EventNode2 := TreeView2.Items.AddChild(OtsikkoNode, '');
    end
    else EventNode2 := nil;
  end;
end;

procedure TForm1.OpenAlvLaskelma;
begin
  AlvSivu1.Clear;
  KkBox1.Caption := 'Alv-laskelma';
  KkBox1.Left := 400;
  TabEditor1.Hide;
  TabPaikat1.Checked := False;
  KkBox1Start;
end;

{ tehdn alv-laskelmaa }
procedure TForm1.TeeAlvLaskelma;
var
  SumAlv: array[0..15] of Integer;
  TiliAlv: array[0..15] of TStringList;
  SaleS: array[1..2] of TStringList;
  Ix, Iy, Iz, Iw, Iv, Ia, ApuI: Integer;
  ApuS, ApuS2: String;

  procedure AddAlaItems(Ib: Integer);
  var
    SumX, Id, Ic: Integer;
  begin
    Ic := Abs(Ib);
    if TiliAlv[Ic].Count > 0 then
    for Id := 0 to TiliAlv[Ic].Count - 1 do
    begin
      SumX := Integer(TiliAlv[Ic].Objects[Id]);
      if Ib < 0 then SumX := -SumX;
      AlvSivu1.Items.Add(' ' + TiliAlv[Ic].Strings[Id]+ Tab            //SpaceStr(8, ' ') +
      + Format('%.2f', [SumX/100]))
    end;
  end;

  procedure AddAlvItem(Ib: Integer);
  var
    SumX: Integer;
  begin
    AddAlaItems(Ib);
    SumX := SumAlv[Abs(Ib)];
    if Ib < 0 then SumX := -SumX;
    AlvSivu1.Items.Add(VatListTxts[Abs(Ib)] + Tab
      + Format('%.2f', [SumX/100]));
    AlvSivu1.Items.Add('');
  end;

  procedure AddAlvItem2(const Sb: String; Sc: String; Ib: Integer);
  begin
    if Length(Sc) > 2 then
    begin   // alv-prosentista turhat nolladesimaalit pois
      if Sc[Length(Sc)] = '0' then
      begin
        Delete(Sc, Length(Sc), 1);
        if Sc[Length(Sc)] = '0'
        then Delete(Sc, Length(Sc), 1)
        else Insert(',', Sc, Length(Sc));
      end
      else Insert(',', Sc, Length(Sc)-1);
      Sc := Sc + '%';
    end;
    AlvSivu1.Items.Add(Sb + ' ' + Sc + Tab
      + Format('%.2f', [Ib/100]));
    AlvSivu1.Items.Add('');
  end;

begin
  DirtyFlag := DirtyFlag and $FFEF;
  for Ix := 0 to 15 do
  begin
    SumAlv[Ix] := 0;
    TiliAlv[Ix] := TStringList.Create;
  end;
  SaleS[1] := TStringList.Create;
  SaleS[2] := TStringList.Create;
  if Accounts1.Count > 0 then
  for Ix := 0 to Accounts1.Count - 1 do
  if (Accounts1.Objects[Ix] <> nil)
  and (TTreeNode(Accounts1.Objects[Ix]).Data <> nil)
  and (TStringList(TTreeNode(Accounts1.Objects[Ix]).Data).Count > 0)
  and (TTreeNode(Accounts1.Objects[Ix]).Count >= 2)
  and (Copy(TTreeNode(Accounts1.Objects[Ix]).Item[1].Text, 1, 3) = 'vat')
  then
  begin
    ApuS := TTreeNode(Accounts1.Objects[Ix]).Item[1].Text;
    Iy := Length('vat');
    ApuS2 := StrFromStr(ApuS, ' ', ' ', Iy);
    ApuI := StrToNextInt(ApuS, Iy);
    Iy := Form2.VatGrid1.Cols[0].IndexOf(ApuS2);
    if Iy in [1..15] then
    begin
      Iw := 0;
      with TStringList(TTreeNode(Accounts1.Objects[Ix]).Data) do
      for Iv := 0 to Count - 1 do
      begin
        Ia := 1;
        if StrToNextInt(Strings[Iv], Ia) > 0 then    //tositenumero > 0
        begin
          if VertPvm(Strings[Iv]) = 0 then Iw := Iw + Integer(Objects[Iv]);
        end;
      end;
      if Iy in [1..2] then
      begin { myynnit ja myynnin alv lasketaan verokannoittain }
         Iz := SaleS[Iy].IndexOf(IntToStr(ApuI));
         if Iz < 0 then Iz := SaleS[Iy].AddObject(IntToStr(ApuI), nil);
         if Iz >= 0 then SaleS[Iy].Objects[Iz] :=
           Pointer(Integer(SaleS[Iy].Objects[Iz]) + Iw);
      end;
      Inc(SumAlv[Iy], Iw);
      if Iw <> 0 then
      begin
        Ia := Length(AccountTxt);
        TiliAlv[Iy].AddObject('Tili ' + StrFromStr(TTreeNode(Accounts1.Objects[Ix]).Text, ' ', ' ', Ia), Pointer(Iw));
      end;
    end;
  end;
  Otsikko('Alv-laskelma ' + ValKkS2 + ' ', AlvSivu1.Items);
  AlvSivu1.Items.Add('');
  AddAlaItems(-2);
  if SaleS[2].Count > 0 then for Ix := 0 to SaleS[2].Count - 1 do   // myynnin verot
  AddAlvItem2(VatListTxts[2], SaleS[2][Ix], 0-Integer(SaleS[2].Objects[Ix]));
  AddAlvItem(-9);             // EU-tavaraostojen alv
  AddAlvItem(-10);            // EU-palveluostojen alv
  AddAlvItem(-13);            // rakentamispalvelun ostojen alv
  AddAlaItems(4);
  AddAlvItem2(VahVeroTxt, '', SumAlv[4]);  // ostojen alv ym vhennykset
  AlvSivu1.Items.Add('');
  AddAlvItem2(MaksVeroTxt, '',  // myynnin alv ym vhennykset
    0-SumAlv[2]-SumAlv[9]-SumAlv[10]-SumAlv[13]-SumAlv[4]);
  AlvSivu1.Items.Add('');
  AddAlaItems(-1);
  if SaleS[1].Count > 0 then for Ix := 0 to SaleS[1].Count - 1 do   // myynnit verokannoittain
  AddAlvItem2(VatListTxts[1], SaleS[1][Ix], 0-Integer(SaleS[1].Objects[Ix]));
  AddAlvItem(-5);             // EU-tavaramyynti
  AddAlvItem(-6);             // EU-palvelumyynti
  AddAlvItem(7);             // EU-tavaraostot
  AddAlvItem(8);             // EU-palveluostot
  AddAlvItem(-11);            // Rakentamispalvelun myynti
  AddAlvItem(12);            // Rakentamispalvelun ostot
  AlvSivu1.Items.Add(Tab + ' ' + SpaceStr(8, '='));
  SaleS[1].Free;
  SaleS[2].Free;
  for Ix := 0 to 15 do TiliAlv[Ix].Free;
end;

{ Pivkirjan tulostus }
procedure TForm1.Print2Click(Sender: TObject);
begin
  KkBox1.Caption := 'Pivkirjan tulostus';
  KkBox1.Left := 130;
  KkBox1.Tag := 0;
  TabEditor1.Hide;
  TabPaikat1.Checked := False;
  KkBox1Start;
end;

procedure TForm1.ListPvkirja;
var
  Ix, Iy, Iz, Iw, Id, Ik, SumD, SumK: Integer;
  Ok: Boolean;
  ANode: TTreeNode;
  Sx, Tx: String;
begin
  ListItems := TStringList.Create;
  Otsikko(Bold  + 'Pivkirja ' + ValKkS + ' ', ListItems);
  ListItems.Add(Under+ListaOts[1]);
  ListItems.Add('');
  SumD := 0;
  SumK := 0;
  Ok := True;
  if (Paivakirja.Items.Count > 0) and (Paivakirja.Items[0].Count > 0) then
  for Ix := 0 to Paivakirja.Items[0].Count - 1 do
  begin
    ANode := Paivakirja.Items[0].Item[Ix];
    Iy := 1;
    Sx := StrFromStr(ANode.Text, '[', ']', Iy);     // tositenumero
    Tx := StrFromStr(ANode.Text, ' ', ':', Iy);     // pivys
    Iz := 1;
    if KkNro1.ItemIndex > 0                         // onko haluttu kk-numero
    then Ok := StrToIntDef(StrFromStr(Tx, '.', '.', Iz), 0) = KkNro1.ItemIndex;
    if Ok or (KkNro1.ItemIndex = 0) then
    begin
      StrFromStr(ANode.Text, ' ', ' ', Iy);         // tositteen yhteissumman yli
      Inc(Iy, 2);                                   // selitteen kohtaan
      ListItems.Add(Bold+Sx+Tab+Tx+Tab+StrFromStr(ANode.Text, ' ', #0, Iy));
      Id := 0;
      Ik := 0;
      if ANode.Count > 0 then
      for Iz := 0 to ANode.Count - 1 do
      begin
        Iy := 1;
        Sx := StrFromStr(ANode[Iz].Text, #0, ':', Iy); // vientisumma
        Iw := SumTxtToInt(Sx);
        Tx := StrFromStr(ANode[Iz].Text, ' ', #0, Iy); // tilinro ja -nimi
        if Iw >=0
        then Inc(Id, Iw)
        else
        begin
          Inc(Ik, -Iw);
          Sx[1] := Tab;                      // miinusmerkin tilalle Tab
        end;
        ListItems.Add(Tab+Tab+Tx+Tab+Tab+Tab+Sx);
      end;
      Inc(SumD, Id);
      Inc(SumK, Ik);
      ListItems.Add(Bold+Tab+Tab+'Yht.'+Tab+Tab+Tab+
        Format('%.2f', [Id/100]) + Tab + Format('%.2f', [Ik/100]));
      ListItems.Add('');
   end;
  end;
  ListItems.Add(Under+Tab+Tab+ValKkS+' yhteens'+Tab+Tab+Tab+
    Format('%.2f', [SumD/100]) + Tab + Format('%.2f', [SumK/100]));
end;

procedure TForm1.PrintPvkirja;
begin
  Inc(PrintKesken);
  ListPvkirja;
  Print1Click(Self);
  ListItems.Free;
  ListItems := Paakirja1.Items;
  Dec(PrintKesken);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  case TabId of
    2: Paakirja1.Repaint;
    3: Tuloslaskelma1.Repaint;
    4: Tase1.Repaint;
    5: AlvSivu1.Repaint;
  end;
end;

procedure TForm1.Update1Click(Sender: TObject);
begin
  DirtyFlag := $FFFF;
  TeeAccountList1;
  PageControl1Change(Sender);
end;

function TForm1.Talteenko: Word;
begin
  Result := mrNo;
  if Muuttunut then Result :=
    MessageDlg('Tallennetaanko?', mtConfirmation, mbYesNoCancel, 0);
  if Result = mrYes then Save1Click(Save1);
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := Talteenko <> mrCancel;
  if CanClose then
  begin
    WriteIni;
    Accounts1.Free;
    Accounts2.Free;
    AccountNames.Free;
    VatDropTxts.Free;
    VatListTxts.Free;
  end;
end;

procedure TForm1.File1Click(Sender: TObject);
begin
  Save1.Enabled := AccountNode <> nil;
  SaveAs1.Enabled := AccountNode <> nil;
  MuutaPerustietoja1.Enabled := AccountNode <> nil;
  LastFile1.Visible := Length(SaveDialog1.FileName) > 0;
  if LastFile1.Visible then LastFile1.Caption :=
    ExtractFileName(SaveDialog1.FileName);
  Vertailukausi1.Visible := AccountNode <> nil;
end;


procedure TForm1.AdminPage1Click(Sender: TObject);
begin
  if TreeSheet1.TabVisible then TreeSheet1.TabVisible := False
  else TreeSheet1.TabVisible := InputBox('Yllpitosivu', 'Anna tunnus', '0000') = '4321';
  N9.Visible := TreeSheet1.TabVisible;
  PaivNrot1.Visible := TreeSheet1.TabVisible;
  TreeSheet2.TabVisible := TreeSheet1.TabVisible;
end;

procedure TForm1.PageControl1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
  AllowChange := PrintKesken = 0;
end;

procedure TForm1.Ohje1Click(Sender: TObject);
begin
  HtmlHelp(Handle, PChar(ChmFile), HH_DISPLAY_TOPIC, 0);
end;

procedure TForm1.TilikarttaMenu1Popup(Sender: TObject);
begin
  UusiAlatili2.Enabled := (Tilikartta.Selected <> nil) and
  (StrToFirstInt(Tilikartta.Selected.Text, 1) = 0);
end;

{ Tilikartan noden siirto }
procedure TForm1.TilikarttaDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  AnItem: TTreeNode;
  AttachMode: TNodeAttachMode;
  HT: THitTests;
  TreeN: TTreeNode;
begin
  if not (Source is TTreeView) or (Tilikartta.Selected = nil) then Exit;
  HT := Tilikartta.GetHitTestInfoAt(X, Y);
  AnItem := Tilikartta.GetNodeAt(X, Y);
  if (Tilikartta.Selected = AnItem) or (Tilikartta.Selected.Data = nil)
  or (AnItem.Data = nil) then Exit;
  if (HT - [htOnButton, htOnLabel, htOnIndent] <> HT) then
  begin
    TreeN := TTreeNode(AnItem.Data);
    if htOnLabel in HT then
    begin
      if (StrToFirstInt(AnItem.Text, 1) <> 0)
      and (TreeN.Count = 0) then Exit;
      TreeN := TreeN[0];
      AttachMode := naAddChild;
    end
    else AttachMode := naInsert;
    Tilikartta.Selected.MoveTo(AnItem, AttachMode);
    TTreeNode(Tilikartta.Selected.Data).MoveTo(TreeN, AttachMode);
    DirtyFlag := $FFFF;
    Muuttunut := True;
  end;
end;

procedure TForm1.TilikarttaDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
var
  ApuN: TTreeNode;
begin
  ApuN := Tilikartta.GetNodeAt(X, Y);
  Accept := (Source is TTreeView)
  and (ApuN <> nil) and (ApuN.Data <> nil);
end;

{ pivmrkentn nppinksittely; select length pidetn 1 merkinmittaisena }
procedure TForm1.Pvm1Click(Sender: TObject);
begin
  TEdit(Sender).SelLength := 1;
end; 

{ pivmrkentn nppinksittely; hyptn pisteiden yli ja ohjataan nuolinppimi }
procedure TForm1.Pvm1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ApuS: String;
begin
  with TEdit(Sender) do
  begin
    if Key in [VK_RIGHT, VK_LEFT] then SelStart := SelStart - 1;
    if SelStart in [2, 5] then
    begin
      if Text[SelStart + 1] <> '.' then
      begin
        ApuS := Text;
        ApuS[SelStart + 1] := '.';
        Text := ApuS;
      end;
      if (Key = VK_LEFT) then SelStart := SelStart - 1
      else SelStart := SelStart + 1;
    end;
    SelLength := 1;
  end;
end;

procedure TForm1.UusiPvm1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_DELETE then Key := 0;
end;

procedure TForm1.UusiPvm1KeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9']) then Key := #0;
end;

procedure TForm1.Alvtekstit1Click(Sender: TObject);
begin
  with Form2 do
  begin
    VatGrid1.Cols[1].Assign(VatDropTxts);
    VatGrid1.Cols[2].Assign(VatListTxts);
    VatGrid1.Cells[1,0] := 'Pudotusvalikossa';
    VatGrid1.Cells[2,0] := 'Alv-laskelmassa';
    VahVero1.Text := VahVeroTxt1;
    MaksVero1.Text := MaksVeroTxt1;
    VahVero2.Text := VahVeroTxt;
    MaksVero2.Text := MaksVeroTxt;
    Form2.Caption := 'Muokkaa';
    ShowMe(VatBox1);
  end;
end;

procedure TForm1.PaivNrot1Click(Sender: TObject);
var
  Ix, Iy, Iz: Integer;
begin
  if (EventNode <> nil) and (EventNode.Count > 0) then
  begin
    Iz := Pos(EventTxt, EventNode[0].Text);
    if Iz > 0 then
    begin
      Iz := Length(EventTxt);
      Iy := StrToNextInt(EventNode[0].Text, Iz);
      if EventNode.Count > 1 then
      for Ix := 1 to EventNode.Count - 1 do
      begin
        Iz := Pos(EventTxt, EventNode[Ix].Text);
        if Iz > 0 then
        begin
          Inc(Iy);
          EventNode[Ix].Text := EventTxt + ' ' + IntToStr(Iy);
        end;
      end;
      DirtyFlag := $FFFF;
      Muuttunut := True;
      OpenPaivakirja;
    end;
  end;
end;

procedure TForm1.Muokkaa2Click(Sender: TObject);
begin
  Valisaldot1.Visible := TabId = 2;
  TabPaikat1.Checked := TabEditor1.Visible;
  Suodatin2.Checked := SuodatinOn.Checked;
  EtsiSeuraava2.Visible := HakuOn;
end;

procedure TForm1.Valisaldot1Click(Sender: TObject);
begin
  Valisaldot1.Checked := not Valisaldot1.Checked;
  ValiSaldot := Valisaldot1.Checked;
  TeePaakirja;
end;

procedure TForm1.Print4Click(Sender: TObject);
begin
  TilikarttaPrint1.Show;
end;

procedure TForm1.Cancel4Click(Sender: TObject);
begin
  TilikarttaPrint1.Hide;
end;

// Tilikartan tulostus
procedure TForm1.OK4Click(Sender: TObject);
begin
  TilikarttaPrint1.Hide;
  Print1Click(Sender);
end;

procedure TForm1.Alvmuut1Click(Sender: TObject);
var
  NodeList: TList;
  Ix, Iy, Iz, Iw: Integer;
  ApuS: String;
begin
  if AccountNode <> nil then
  begin
    AlvEditRow := -1;
    AlvMuutPanel.Left := PerusTiedot1.Left;
    AlvMuutPanel.Show;
    NodeList := TList.Create;
    FindNodeTxts(AccountNode, NodeList, 'vat ');
    if NodeList.Count > 0 then
    begin
      for Ix := 0 to NodeList.Count - 1 do
      if Length(TTreeNode(NodeList[Ix]).Text) > 5 then
      begin
        Iw := 5;
        Iz := StrToNextInt(TTreeNode(NodeList[Ix]).Text, Iw);
        if (Iz > 0) or (TTreeNode(NodeList[Ix]).Text[Length(TTreeNode(NodeList[Ix]).Text)] in ['0'..'9']) then
        begin
          ApuS := IntToStrDes(Iz, 2);
          for Iy := 1 to 3 do
          if (Length(TTreeNode(NodeList[Ix]).Text) > (5 + Length(VatTexts[Iy])))
          and (StrLComp(PChar(VatTexts[Iy]), @(TTreeNode(NodeList[Ix]).Text[5]), Length(VatTexts[Iy])) = 0) then
          begin
            Iz := AlvMuutGrid1.Cols[0].IndexOf(ApuS);
            if Iz < 0 then
            begin
              if AlvMuutGrid1.Objects[0, 0] = nil
              then Iz := 0
              else
              begin
                Iz := AlvMuutGrid1.RowCount;
                AlvMuutGrid1.RowCount := Iz + 1;
                AlvMuutGrid1.Objects[0, Iz] := nil;
                AlvMuutGrid1.Cells[1, Iz] := '';
              end;
              AlvMuutGrid1.Cells[0, Iz] := ApuS;
            end;
            if AlvMuutGrid1.Objects[0, Iz] = nil
            then AlvMuutGrid1.Objects[0, Iz] := TList.Create;
            TList(AlvMuutGrid1.Objects[0, Iz]).Add(NodeList[Ix]);
            Break;
          end;
        end;
      end;
    end;
    AlvMuutGrid1.Row := 0;
    AlvMuutGrid1.Col := 1;
    NodeList.Free;
  end;
end;

procedure TForm1.Cancel5Click(Sender: TObject);
var
  Ix: Integer;
begin
  with AlvMuutGrid1 do
  begin
    for Ix := 0 to RowCount - 1 do
    if Objects[0, Ix] <> nil
    then TList(Objects[0, Ix]).Free;
    RowCount := 1;
    Objects[0, 0] := nil;
    Cells[0, 0] := '';
    Cells[1, 0] := '';
  end;
  AlvMuutPanel.Hide;
end;

procedure TForm1.AlvMuutGrid1KeyPress(Sender: TObject; var Key: Char);
begin
  with AlvMuutGrid1 do
  begin
    AlvEditRow := Row;
    if Key = #13 then
    if Row < (RowCount - 1)
    then Row := Row + 1
    else AlvMuutCellFix;
  end;
end;

procedure TForm1.AlvMuutCellFix;
var
  Ix: Integer;
begin
  if AlvEditRow >= 0 then
  begin
    with AlvMuutGrid1 do
    if (AlvEditRow < RowCount) and (Length(Cells[1, AlvEditRow]) > 0) then
    begin
      Ix := CellToIntDes(Cells[1, AlvEditRow], 2);
      if (Ix > 0) or (Cells[1, AlvEditRow][1] = '0')
      then Cells[1, AlvEditRow] := IntToStrDes(Ix, 2)  // siistitn luku
      else Cells[1, AlvEditRow] := '';
    end;
    AlvEditRow := -1;
  end;
end;

procedure TForm1.AlvMuutGrid1SelectCell(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
begin
  AlvMuutCellFix;
end;

procedure TForm1.Ok5Click(Sender: TObject);
var
  ApuI, Ix, Iy, Iz, Iw: Integer;
  ApuP: TPoint;
  ApuS, ApuT, ApuU: String;
  ApuN: TTreeNode;

  procedure LoppuNollatPois(var S: String);
  begin
    while (Length(S) > 0) and (S[Length(S)] = '0')
    do SetLength(S, Length(S) - 1);
    // mys des.pilkku pois, jos desimaalit oli nollia
    if (Length(S) > 0) and (S[Length(S)] = DesP)
    then SetLength(S, Length(S) - 1);
  end;

begin
  if AlvMuutGrid1.Objects[0, 0] = nil then Exit;
  AlvMuutCellFix;
  ApuP.X := 0;
  ApuP.Y := AlvMuutPanel.Height;
  ApuP := AlvMuutPanel.ClientToScreen(ApuP);
  if MessageDlgPos('Muutetaanko alv-prosentit?', mtConfirmation,
    [mbYes, mbNo], 0, ApuP.X, ApuP.Y) = mrYes then
  with AlvMuutGrid1 do
  begin
    for Ix := 0 to RowCount - 1 do
    if (Objects[0, Ix] <> nil) and (Length(Cells[1, Ix]) > 0) then
    begin
      ApuI := CellToIntDes(Cells[1, Ix], 2);
      if (ApuI > 0) or (Cells[1, Ix][1] = '0') then
      with TList(Objects[0, Ix]) do
      if Count > 0 then
      for Iy := 0 to Count - 1 do
      with TTreeNode(Items[Iy]) do
      begin
        Iz := 5;
        while (Iz <= Length(Text)) and not (Text[Iz] in ['0'..'9']) do Inc(Iz);
        if Iz <= Length(Text) then
        begin
          Muuttunut := True;
          Text := Copy(Text, 1, Iz - 1) + IntToStr(ApuI);
          // etsitn, onko parentnoden tekstiss sama alv-%
          ApuN := Parent;
          if ApuN <> nil then
          begin
            if Pos(AccountTxt, ApuN.Text) = 1 then
            begin
              ApuS := Cells[0, Ix];
              LoppuNollatPois(ApuS);
              ApuT := Cells[1, Ix];
              LoppuNollatPois(ApuT);
              Iz := NumLength(Copy(ApuN.Text, Length(AccountTxt) + 2, Length(ApuN.Text) - Length(AccountTxt)));
              if Iz > 0 then
              begin
                Iz := Iz + Length(AccountTxt) + 2;
                Iw := Pos(ApuS, Copy(ApuN.Text, Iz + 1, Length(ApuN.Text) - Iz));
                if Iw > 0 then
                begin
                  ApuU := ApuN.Text;
                  System.Delete(ApuU, Iz + Iw, Length(ApuS));
                  System.Insert(ApuT, ApuU, Iz + Iw);
                  ApuN.Text := ApuU;
                end;
              end;
            end;
          end;
        end;
      end;
    end;
    Cancel5Click(Sender);
  end;
end;


procedure TForm1.KkNro1Change(Sender: TObject);
var
  ApuI: Integer;
begin
  if not KkVvChange and VvNro1.Visible then
  begin
    KkVvChange := True;
    if KkNro1.ItemIndex = 0
    then VvNro1.ItemIndex := 0
    else if VvNro1.ItemIndex < 1 then
    begin
      ApuI := VvNro1.Items.IndexOf(IntToStr(LongRec(MaxKk).Hi));
      if ApuI < 0 then ApuI := VvNro1.Items.Count - 1;
      VvNro1.ItemIndex := ApuI;
    end;
    KkVvChange := False;
  end;
end;

procedure TForm1.VvNro1Change(Sender: TObject);
begin
  if not KkVvChange and (VvNro1.ItemIndex = 0) then
  begin
    KkVvChange := True;
    KkNro1.ItemIndex := 0;
    KkVvChange := False;
  end;
end;

procedure TForm1.KkBox1Start;
var
  ApuI: Integer;
begin
  KkNro1.ItemIndex := LongRec(MaxKk).Lo;
  if VvNro1.Visible then
  begin
    ApuI := VvNro1.Items.IndexOf(IntToStr(LongRec(MaxKk).Hi));
    if ApuI < 0 then ApuI := 0;
    VvNro1.ItemIndex := ApuI;
  end;
  KkBox1.Show;
end;

procedure TForm1.SuodOKClick(Sender: TObject);
begin
  Suodatin1.Hide;
  SuodatinText := Trim(Suod1.Text);
  if Length(SuodatinText) = 0 then SuodatinOn.Checked := False;
  DirtyFlag := $FFFF;
  PageControl1.ActivePage := PaivaSheet2;
end;

procedure TForm1.Suodatin2Click(Sender: TObject);
begin
  Suodatin1.Left := 100;
  Suodatin1.Show;
end;

procedure TForm1.Etsi1Click(Sender: TObject);
begin
  HakuIx := 0;
  if ((HakuTreeView <> nil) or (HakuListBox <> nil))
    and InputQuery('Etsi', '', HakuStr) then
  begin
    if Length(HakuStr) = 0 then Exit;
    HakuStr := LowerCase(HakuStr);
    if HakuTreeView <> nil then
    begin
      HaeString;
      HakuTreeView.SetFocus;
    end
    else
    begin
      HaeListString;
      HakuListBox.SetFocus;
    end;
  end;
end;

procedure TForm1.HaeString;
var
  Ix: Integer;
  Ok: Boolean;
begin
  if HakuTreeView = nil then Exit;
  HakuOn := True;
  Ok := False;
  if (HakuTreeView.Items.Count > 0) and (HakuTreeView.Items[0].Count > HakuIx) then
  for Ix := HakuIx to HakuTreeView.Items[0].Count - 1 do
  if HaeNodeStr(HakuTreeView.Items[0].Item[Ix]) then
  begin
    HakuIx := Ix;
    Ok := True;
    Break;
  end;
  if not Ok then ShowMessage(HakuStr + ' ei lydy!');
end;

function TForm1.HaeNodeStr(ANode: TTreeNode): Boolean;
var
  Ix: Integer;
begin
  Result := False;
  if ((HakuTreeView.Selected = nil) or (ANode.AbsoluteIndex > HakuTreeView.Selected.AbsoluteIndex))
    and (Pos(HakuStr, LowerCase(ANode.Text)) > 0) then
  begin
    HakuTreeView.Selected := ANode;
    Result := True;
  end
  else if ANode.Count > 0 then
  for Ix := 0 to ANode.Count - 1 do
  if HaeNodeStr(ANode.Item[Ix]) then
  begin
    Result := True;
    Break;
  end;
end;

procedure TForm1.Etsiseuraava1Click(Sender: TObject);
begin
  if HakuTreeView <> nil
  then HaeString
  else if HakuListBox <> nil then HaeListString;
end;

procedure TForm1.KeyDown1(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if ssCtrl in Shift then
  begin
    case Key of
    Ord('f'), Ord('F'): Etsi1Click(Sender);
    Ord('g'), Ord('G'), Ord('l'), Ord('L'): if HakuOn then Etsiseuraava1Click(Sender);
    end;
  end;
end;

procedure TForm1.HaeListString;
var
  Ix, Iy: Integer;
  Ok: Boolean;
begin
  if HakuListBox = nil then Exit;
  HakuOn := True;
  Ok := False;
  Iy := HakuListBox.ItemIndex;
  if Iy < 0 then Iy := 0 else Inc(Iy);
  if HakuListBox.Items.Count > Iy then
  for Ix := Iy to HakuListBox.Items.Count - 1 do
  if Pos(HakuStr, LowerCase(HakuListBox.Items[Ix])) > 0 then
  begin
    HakuListBox.ItemIndex := Ix;
    Ok := True;
    Break;
  end;
  if not Ok then ShowMessage(HakuStr + ' ei lydy!');
end;

// Pkirjan, Tuloslaskelman, Taseen ja Alv-laskelman otsikko muutettavissa
procedure TForm1.Tase1DblClick(Sender: TObject);
begin
  with TListBox(Sender).Items do
  if Count > 2 then
  begin
    Strings[1] := InputBox('Muutetaan', 'Uusi otsikko', Strings[1]);
  end;
end;

end.
